<?php

namespace HCM\AVL\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;
use HCM\Util\DateUtil;
use Teknisa\Model\Gestaopessoas\Entities\Questao;

class BancoQuestoesService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function deleteQuestao($dataset) {
        $nrquestao = $dataset["NRQUESTAO"];
        $registrosfilhos = $this->entityManager->getRepository(Repositories::QUESTAO)->findBy(array("nrquestao" => $nrquestao, "nrorg" => $dataset['NRORG']));
        $registrosResposta = $this->entityManager->getRepository(Repositories::RESPOSTA)->findBy(array("nrquestao" => $nrquestao, "nrorg" => $dataset['NRORG']));
        $registrosTipoAval = $this->entityManager->getRepository(Repositories::QUESTIPOAVAL)->findBy(array("nrquestao" => $nrquestao, "nrorg" => $dataset['NRORG']));
        $registrosNivelAval = $this->entityManager->getRepository(Repositories::NIVELQUESTAVAL)->findBy(array("nrquestao" => $nrquestao, "nrorg" => $dataset['NRORG']));
        if(empty($registrosResposta) && empty($registrosTipoAval) && empty($registrosNivelAval)){
           return true;
        }else{
            throw new \Exception(Messages::HCM03000_AVL_QUESTAO_POSSUI_REGISTROSFILHOS, 10);
        }
        
    }
    
   

}