<?php

namespace HCM\FPA\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\HCMParameters;
use HCM\FPA\Services\RelatCustomPensionistaService;

class RelatCustomPensionistaController extends Crud {

    public function __construct (Manager $dataSourceManager, RelatCustomPensionistaService $relatCustomPensionistaService){
        $this->relatCustomPensionistaService = $relatCustomPensionistaService;
        parent::__construct($dataSourceManager);
    }

    public function getRelatCustomPensionista(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            set_time_limit(0);
            ini_set('memory_limit', '2048M');
            $filters = \HCM\Util\Util::removerCaracterePorcentagemString($request->getFilterCriteria()->getConditions());
            $result = $this->relatCustomPensionistaService->getRelatCustomPensionista($filters);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getRelatCustomPensionista', $result));
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }
} 