<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;

class RelatCustomMovimentacaoRepository {

    protected  $connection;
    protected  $selectEstruturaSuperior;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        $this->selectEstruturaSuperior = '';
    }

    static $pivotINelements;
    static $pivotSELECTelements;

    /**
     * @return array
     */

    public function getRelatCustomMovimentacaoFinanceiro($parameters, $filters) {

        $estruturaSuperior = '';
        if (isset($parameters['P_NRTIPOHIERARQORG']) && $parameters['P_NOMETIPOSESTRUTURA']) {
          $nomeTipoEstrutura = $parameters['P_NOMETIPOSESTRUTURA'];
          $tiposHierarquiaOrg = "'".$parameters['P_NRTIPOHIERARQORG']."'";
          $this->setSelectEstruturaSuperior($nomeTipoEstrutura);

          $estruturaSuperior = "JOIN (
            SELECT *
            FROM( SELECT         
                VH.NRVINCULOM,
                EM.NRESTRUTURAM,
                EM.NMESTRUTURAM,
                TPE.NMTIPOESTRUTURA
              FROM ESTRUTURAM EM
              JOIN TIPOESTRUTURA TPE ON TPE.NRTIPOESTRUTURA = EM.NRTIPOESTRUTURA
              JOIN GPE_VINCULOH VH  ON VH.NRORG = EM.NRORG  
                                        AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H
                                                                  WHERE H.NRORG = VH.NRORG  
                                                                    AND H.NRVINCULOM = VH.NRVINCULOM
                                                                    AND H.DTMESCOMPETENC <= :P_DTMESCOMPETENC )
              JOIN HIERARQUIAORG H ON H.NRORG            = VH.NRORG
                            AND H.NRESTRUTURAMREL  = VH.NRESTRUTGEREN
                            AND ( INSTR(','||$tiposHierarquiaOrg||',', ','||H.NRTIPOHIERARQORG||',') > 0 ) 
                            AND H.NRESTRUTURAMSUP  = EM.NRESTRUTURAM
                            AND H.DTINIVIGENCIA    = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG
                                                      WHERE DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC) 
                                                        AND NRORG            = H.NRORG
                                                        AND NRESTRUTURAMREL  = H.NRESTRUTURAMREL
                                                        AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG )
              WHERE EM.NRORG = :P_NRORG
                AND ( INSTR(','||$tiposHierarquiaOrg||',', ','||H.NRTIPOHIERARQORG||',') > 0 ) 
            )
            PIVOT ( MAX(NRESTRUTURAM) as NR,
                      MAX(NMESTRUTURAM) AS NM
                      FOR NMTIPOESTRUTURA IN ($nomeTipoEstrutura))) ESTRUTURASUPERIOR ON ESTRUTURASUPERIOR.NRVINCULOM = GPE_VINCULOM.NRVINCULOM";
        }

      $param = self::selectMovimentacoes(isset($parameters['DADOSVINCULO'])?$parameters['DADOSVINCULO']:'N');
      $groupby = $param[1];
      $select = $param[0];
      $generalWhere = self::getWhereFilters($filters);
      
      if(array_key_exists('NRTIPOMOVIMENT', $parameters)){
          $tipomoviment = implode(",", $parameters['NRTIPOMOVIMENT']);
          $condicaoMovimento = 'AND FPA_CALCULOFOLHA.NRTIPOMOVIMENT IN ('.$tipomoviment.')';
      }else {
          $condicaoMovimento = ' ';
      }
  
      if(array_key_exists('P_NRTIPOHIERARQORG', $parameters)) {
          $tipohierarquia = $parameters['P_NRTIPOHIERARQORG'];
          if(is_array($parameters['P_NRTIPOHIERARQORG'])){
              $tipohierarquia =  implode(",", $parameters['P_NRTIPOHIERARQORG']);
          }
          $tipohierarquia = "AND ( INSTR(',' ||'$tipohierarquia'|| ',', ',' || HIERARQUIAORG.NRTIPOHIERARQORG || ',') > 0 )";
      }else{
          $tipohierarquia =  "AND 1 = 2";
      }

      if (array_key_exists('P_NRTIPOHIERARQORG', $parameters)) {
          $tipohierarquiaWhere = $parameters['P_NRTIPOHIERARQORG'];
          if(is_array($parameters['P_NRTIPOHIERARQORG'])){
              $tipohierarquiaWhere =  implode(",", $parameters['P_NRTIPOHIERARQORG']);
          }
          $tipohierarquiaWhere = "AND ( INSTR(',' ||'$tipohierarquiaWhere'|| ',', ',' || HIERARQUIAORG.NRTIPOHIERARQORG || ',') > 0 )";
      } else {
          $tipohierarquiaWhere =  "";
      }
      
      if(array_key_exists('NRTPESTRUTMOVIM', $parameters)) {
          $tipoEstruturaMov = $parameters['NRTPESTRUTMOVIM'];
      }else{
          $tipoEstruturaMov = 0;
      }

      //Montagem do filtro de escopo do calculo folha
      $whereCalc = " "; 
        if(empty($parameters['DTOCORRENCIA'][0])){
          //Não há datas de escopo, usando a competência
          $whereCalc = " AND FPA_CALCULOFOLHA.DTOCORRENCIA = TO_DATE('".$parameters['P_DTMESCOMPETENC']."', 'DD/MM/YYYY') ";
        } else if(empty($parameters['DTOCORRENCIA'][1])){
            //Data de inicio preenchida e data de fim vazia
            $whereCalc = " AND FPA_CALCULOFOLHA.DTOCORRENCIA >= TRUNC(ADD_MONTHS(TO_DATE('".$parameters['DTOCORRENCIA'][0]."', 'DD/MM/YYYY') , -1), 'MONTH') ";
        } else{
            //Todas as datas preenchidas
            $whereCalc = " AND FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN TRUNC(ADD_MONTHS(TO_DATE('".$parameters['DTOCORRENCIA'][0]."', 'DD/MM/YYYY') , -1), 'MONTH') AND '".$parameters['DTOCORRENCIA'][1]."' ";
        }
      
      //Verifica se deve ignorar ou não a ocorrência de calculo e faz o ajuste no where do calculo folha
      $ignoraOcorrecal = isset($parameters['IGNORAOCORRECAL'])?$parameters['IGNORAOCORRECAL']:'N';
      if($ignoraOcorrecal == 'N') {
          $whereCalc .= " AND FPA_CALCULOFOLHA.NROCORRECAL = " . $parameters['NROCORRECAL'];
      }

      //Montagem do filtro de escopo do item de cálculo
      $whereItem = " ";
      if(array_key_exists('DTOCORRENCIA', $parameters)){
          if(!empty($parameters['DTOCORRENCIA'][0])){
              //Data de inicio vazia e data de fim preenchida
              $whereItem = " AND FPA_ITECALCFOLHA.DTOCORRENCIA <= TO_DATE('".$parameters['DTOCORRENCIA'][0]."', 'DD/MM/YYYY')  ";
          }
          if(empty($parameters['DTOCORRENCIA'][1])){
              //Data de inicio preenchida e data de fim vazia
              $whereItem = " AND FPA_ITECALCFOLHA.DTOCORRENCIA >= TO_DATE('".$parameters['DTOCORRENCIA'][0]."', 'DD/MM/YYYY')  ";
          }else{
              //Todas as datas preenchidas
              $whereItem = " AND FPA_ITECALCFOLHA.DTOCORRENCIA BETWEEN TO_DATE('".$parameters['DTOCORRENCIA'][0]."', 'DD/MM/YYYY')  AND TO_DATE('".$parameters['DTOCORRENCIA'][1]."', 'DD/MM/YYYY') ";
          }
      }

     if(array_key_exists('NRESTRUTLEGAL', $parameters)) {
        $nrestrutlegal = implode(",", $parameters['NRESTRUTLEGAL']);
        $condEstrutLegal = "AND VINCULOH.NRESTRUTLEGAL IN ($nrestrutlegal)";
      } else {
        $condEstrutLegal = "";
      }

      if(array_key_exists('NRESTRUTGEREN', $parameters)) {
          $nrestrutgeren = implode(",", $parameters['NRESTRUTGEREN']);
          $condEstrutGeren = "AND VINCULOH.NRESTRUTGEREN IN ($nrestrutgeren)";
      } else {
        $condEstrutGeren = "";
      }
      
      if(array_key_exists('NRESTRUTSIND', $parameters)) {
          $nrestrutsind = implode(",", $parameters['NRESTRUTSIND']);
          $condEstrutSind = "AND VINCULOH.NRESTRUTSIND IN ($nrestrutsind)";
      } else {
        $condEstrutSind = "";
      }

      if(array_key_exists('NRVINCULOM', $parameters)){
          $listVinculos = implode(",", $parameters['NRVINCULOM']);
          $condicaoVinculos = "AND FPA_ITECALCFOLHA.NRVINCULOM IN ($listVinculos)";
      }else {
          $condicaoVinculos = ' ';
      }

      if(array_key_exists('NREVENTOM', $parameters)){
          $listaEventos = implode(",", $parameters['NREVENTOM']);
          $condicaoEventos = "AND FPA_ITECALCFOLHA.NREVENTOM IN ($listaEventos)";
      }else {
          $condicaoEventos = ' ';
      }
      $sql = "/*SELECT *
            FROM (SELECT
  RES.*,
  MAX(RES.FLAG) OVER (PARTITION BY RES.NRESTRUTLEGAL, RES.NRESTRUTGEREN, RES.NREVENTOM) AS FLAG2
FROM (*/".$select."
        FROM FPA_CALCULOFOLHA

        JOIN FPA_ITECALCFOLHA
               ON FPA_ITECALCFOLHA.NRCALCULOFOLHA = FPA_CALCULOFOLHA.NRCALCULOFOLHA
              AND FPA_ITECALCFOLHA.NRORG          = FPA_CALCULOFOLHA.NRORG
              $condicaoVinculos
              $condicaoEventos
              $whereItem
        JOIN GPE_VINCULOM
            ON (GPE_VINCULOM.NRORG         = FPA_ITECALCFOLHA.NRORG
            AND GPE_VINCULOM.NRVINCULOM    = FPA_ITECALCFOLHA.NRVINCULOM)
        JOIN GPE_VINCULOH VINCULOH
            ON (GPE_VINCULOM.NRORG           = VINCULOH.NRORG
           AND  GPE_VINCULOM.NRVINCULOM      = VINCULOH.NRVINCULOM)
           AND VINCULOH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC)
                                           FROM ( SELECT DTMESCOMPETENC FROM GPE_VINCULOH H1
                                                  WHERE H1.NRORG           = VINCULOH.NRORG
                                                    AND H1.NRVINCULOM      = VINCULOH.NRVINCULOM
                                                    AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                                                  ORDER BY DTMESCOMPETENC DESC )
                                           WHERE ROWNUM = 1 )
        LEFT JOIN FPA_TPADMISSAO ON FPA_TPADMISSAO.NRTPADMISSAO = GPE_VINCULOM.NRTPADMISSAO
        
         /*Ocupação*/
         LEFT JOIN GPE_OCUPACAOH
                ON GPE_OCUPACAOH.NROCUPACAOM     = VINCULOH.NRCARGO
               AND GPE_OCUPACAOH.NRORG          = VINCULOH.NRORG
               AND GPE_OCUPACAOH.DTMESCOMPETENC = (SELECT MAX(H.DTMESCOMPETENC)
                                                     FROM GPE_OCUPACAOH H
                                                    WHERE H.NRORG         = GPE_OCUPACAOH.NRORG
                                                      AND H.NROCUPACAOM     = GPE_OCUPACAOH.NROCUPACAOM
                                                      AND H.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
        LEFT JOIN GPE_TIPOVINCULOM 
               ON GPE_TIPOVINCULOM.NRTIPOVINCULOM = GPE_VINCULOM.NRTIPOVINCULOM
              AND GPE_TIPOVINCULOM.NRORG = :P_NRORG_PADRAO
        LEFT JOIN GPE_TIPOVINCULOH GVH
               ON GVH.NRTIPOVINCULOM = GPE_TIPOVINCULOM.NRTIPOVINCULOM
              AND GVH.NRORG = GPE_TIPOVINCULOM.NRORG
              AND GVH.DTMESCOMPETENC =
                   (SELECT MAX(DTMESCOMPETENC)
                      FROM GPE_TIPOVINCULOH 
                     WHERE NRORG           = GVH.NRORG
                       AND NRTIPOVINCULOM  = GVH.NRTIPOVINCULOM
                       AND DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                       
        /*EVENTOS*/
        JOIN FPA_EVENTOM
            ON  (FPA_EVENTOM.NRORG        = FPA_ITECALCFOLHA.NRORG OR FPA_EVENTOM.NRORG = :P_NRORG_PADRAO)
            AND (FPA_EVENTOM.NREVENTOM    = FPA_ITECALCFOLHA.NREVENTOM)
        JOIN FPA_EVENTOH EVENTOH
            ON  (FPA_EVENTOM.NRORG           = EVENTOH.NRORG OR FPA_EVENTOM.NRORG = :P_NRORG_PADRAO)
            AND (FPA_EVENTOM.NREVENTOM       = EVENTOH.NREVENTOM
            AND EVENTOH.DTMESCOMPETENC   =
                (SELECT MAX(DTMESCOMPETENC)
                        FROM FPA_EVENTOH
                        WHERE NRORG             = EVENTOH.NRORG
                            AND NREVENTOM       = EVENTOH.NREVENTOM
                            AND DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')))
                            
        /*ESTRUTURAS*/
        LEFT JOIN ESTRUTURAM ESTRUTLEGALM
            ON (VINCULOH.NRORG         = ESTRUTLEGALM.NRORG
           AND  VINCULOH.NRESTRUTLEGAL = ESTRUTLEGALM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTLEGALH
            ON (ESTRUTLEGALM.NRORG        = ESTRUTLEGALH.NRORG
           AND  ESTRUTLEGALM.NRESTRUTURAM = ESTRUTLEGALH.NRESTRUTURAM
       AND  ESTRUTLEGALH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTLEGALH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTLEGALH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')))
        LEFT JOIN ESTRUTURAM ESTRUTGERENCM
            ON (VINCULOH.NRORG         = ESTRUTGERENCM.NRORG
           AND  VINCULOH.NRESTRUTGEREN = ESTRUTGERENCM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTGERENCH
            ON (ESTRUTGERENCM.NRORG        = ESTRUTGERENCH.NRORG
           AND  ESTRUTGERENCM.NRESTRUTURAM = ESTRUTGERENCH.NRESTRUTURAM)
       AND  ESTRUTGERENCH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTGERENCH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTGERENCH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
        LEFT JOIN ESTRUTURAM ESTRUTSINDM
            ON (VINCULOH.NRORG         = ESTRUTSINDM.NRORG
           AND  VINCULOH.NRESTRUTSIND  = ESTRUTSINDM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTSINDH
            ON (ESTRUTSINDM.NRORG        = ESTRUTSINDH.NRORG
           AND  ESTRUTSINDM.NRESTRUTURAM = ESTRUTSINDH.NRESTRUTURAM)
       AND  ESTRUTSINDH.DTMESCOMPETENC =
                                             (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTSINDH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTSINDH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                                                 
        /*ESTRUTURA - MOVIMENTAÇÃO*/
        LEFT JOIN ESTRUTURAM ESTRUTMOVIMM ON ESTRUTMOVIMM.NRORG        = VINCULOH.NRORG
                                         AND ESTRUTMOVIMM.NRESTRUTURAM = ( SELECT NRESTRUTURAM FROM GPE_MOVIMENTACAO M
                                                                          WHERE M.DTINIMOVIMENT = ( SELECT MAX(DTINIMOVIMENT) FROM GPE_MOVIMENTACAO
                                                                                                    WHERE DTINIMOVIMENT <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                                                                                                      AND NRTIPOESTRUTURA = M.NRTIPOESTRUTURA
                                                                                                      AND NRORG           = VINCULOH.NRORG
                                                                                                      AND NRVINCULOM      = VINCULOH.NRVINCULOM )
                                                                            AND M.NRMOVIMENTACAO = ( SELECT MAX(NRMOVIMENTACAO) FROM GPE_MOVIMENTACAO
                                                                                                     WHERE DTINIMOVIMENT = M.DTINIMOVIMENT
                                                                                                      AND NRTIPOESTRUTURA = M.NRTIPOESTRUTURA
                                                                                                      AND NRORG = VINCULOH.NRORG
                                                                                                      AND NRVINCULOM = VINCULOH.NRVINCULOM )
                                                                            AND (M.DTFIMMOVIMENT IS NULL OR M.DTFIMMOVIMENT >= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                                                                            AND M.NRTIPOESTRUTURA = :P_NRTIPOESTRUTURA
                                                                            AND M.NRORG = VINCULOH.NRORG
                                                                            AND M.NRVINCULOM = VINCULOH.NRVINCULOM )
        LEFT JOIN ESTRUTURAH ESTRUTMOVIMH ON ESTRUTMOVIMH.NRORG          = VINCULOH.NRORG
                                         AND ESTRUTMOVIMH.NRESTRUTURAM   = ESTRUTMOVIMM.NRESTRUTURAM
                                         AND ESTRUTMOVIMH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                             WHERE DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                                                                               AND NRORG        = VINCULOH.NRORG
                                                                               AND NRESTRUTURAM = ESTRUTMOVIMM.NRESTRUTURAM )
                                                                               
        /*PESSOA */
        JOIN GPE_PESSOA
            ON GPE_VINCULOM.NRPESSOA = GPE_PESSOA.NRPESSOA
           AND GPE_VINCULOM.NRORG = GPE_PESSOA.NRORG
        JOIN GPE_PESSOAH
            ON GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA
           AND GPE_PESSOAH.NRORG = GPE_PESSOA.NRORG
           AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT MAX(MAX_PESSOAH.DTMESCOMPETENC)
                                               FROM GPE_PESSOAH MAX_PESSOAH
                                              WHERE MAX_PESSOAH.NRPESSOA = GPE_PESSOAH.NRPESSOA
                                                AND MAX_PESSOAH.NRORG = GPE_PESSOAH.NRORG
                                                AND MAX_PESSOAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                                                
        /*RESCISÃO*/
        LEFT JOIN FPA_TPDEMISSAO
               ON FPA_TPDEMISSAO.NRTPDEMISSAO = GPE_VINCULOM.NRTPDEMISSAO
        LEFT JOIN GPE_MOTIVORESC
               ON GPE_MOTIVORESC.NRMOTIVORESC = GPE_VINCULOM.NRMOTIVORESC
               
        /* INFORMAÇÔES BANCÁRIAS*/
        LEFT JOIN CONTCORRPARC
               ON CONTCORRPARC.NRORG = GPE_VINCULOM.NRORG
              AND CONTCORRPARC.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
        LEFT JOIN BANCO
               ON BANCO.CDBANCO = CONTCORRPARC.CDBANCO
              AND (BANCO.NRORG = GPE_VINCULOM.NRORG OR BANCO.NRORG = :P_NRORG_PADRAO)
        LEFT JOIN AGENCIA
               ON AGENCIA.CDAGENCIA = CONTCORRPARC.CDAGENCIA
              AND AGENCIA.CDBANCO   = CONTCORRPARC.CDBANCO
              AND (AGENCIA.NRORG = GPE_VINCULOM.NRORG OR AGENCIA.NRORG = :P_NRORG_PADRAO)
              
        /*ESTRUTURA SUPERIOR*/
        LEFT JOIN HIERARQUIAORG
               ON HIERARQUIAORG.NRESTRUTURAMREL  = VINCULOH.NRESTRUTGEREN
              AND HIERARQUIAORG.NRORG            = GPE_VINCULOM.NRORG
              $tipohierarquia
        LEFT JOIN ESTRUTURAM ESTRUTSUPERIORM
               ON (VINCULOH.NRORG         = ESTRUTSUPERIORM.NRORG
              AND  HIERARQUIAORG.NRESTRUTURAMSUP = ESTRUTSUPERIORM.NRESTRUTURAM)
        LEFT JOIN ESTRUTURAH ESTRUTSUPERIORH
               ON (ESTRUTSUPERIORM.NRORG        = ESTRUTSUPERIORH.NRORG
              AND  ESTRUTSUPERIORM.NRESTRUTURAM = ESTRUTSUPERIORH.NRESTRUTURAM)
              AND  ESTRUTSUPERIORH.DTMESCOMPETENC =
                                                     (SELECT MAX(DTMESCOMPETENC)
                                                FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.NRORG            = ESTRUTSUPERIORH.NRORG
                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTSUPERIORH.NRESTRUTURAM
                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
        $estruturaSuperior
        /*ASSOCIACAO CONTABIL*/
        LEFT JOIN FPA_TPEVENTOCTBL ON FPA_TPEVENTOCTBL.NRTPEVENTOCTBL = ESTRUTGERENCM.NRTPEVENTOCTBL
                                    AND ( FPA_TPEVENTOCTBL.NRORG = ESTRUTGERENCM.NRORG
                                      OR FPA_TPEVENTOCTBL.NRORG = :P_NRORG_PADRAO )
        LEFT JOIN FPA_EVENTOCTBL
               ON FPA_EVENTOCTBL.NRORG = ESTRUTLEGALM.NRORG
              AND FPA_EVENTOCTBL.NREVENTOM = FPA_ITECALCFOLHA.NREVENTOM
              AND FPA_EVENTOCTBL.DTINIVIGENCIA <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
              AND (FPA_EVENTOCTBL.NRESTRUTURAM = ESTRUTLEGALM.NRESTRUTURAM OR FPA_EVENTOCTBL.NRESTRUTURAM IS NULL)
              AND (FPA_EVENTOCTBL.NRTPEVENTOCTBL = ESTRUTGERENCM.NRTPEVENTOCTBL OR FPA_EVENTOCTBL.NRTPEVENTOCTBL IS NULL)
              AND (FPA_EVENTOCTBL.NRTIPOMOVIMENT = FPA_CALCULOFOLHA.NRTIPOMOVIMENT
                                      OR FPA_EVENTOCTBL.NRTIPOMOVIMENT IS NULL )
        LEFT JOIN DESPADMFATUR
               ON DESPADMFATUR.NRORG = ESTRUTLEGALM.NRORG
              AND DESPADMFATUR.CDDESPADMFAT = FPA_EVENTOCTBL.CDDESPADMFAT
              
        /*Situação Funcional*/
        LEFT JOIN GPE_ALTESITUFUNC ALTF ON ALTF.NRORG      = GPE_VINCULOM.NRORG
                                       AND ALTF.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                                       AND ALTF.DTINISITUFUNC = ( SELECT MAX(DTINISITUFUNC) FROM GPE_ALTESITUFUNC
                                                                  WHERE DTINISITUFUNC <= LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                                                                    AND NRORG      = ALTF.NRORG
                                                                    AND NRVINCULOM = ALTF.NRVINCULOM )
        LEFT JOIN GPE_SITUFUNCH SFH ON ( SFH.NRORG IS NULL OR SFH.NRORG = 0 OR SFH.NRORG = GPE_VINCULOM.NRORG )
                                   AND SFH.NRSITUFUNCM = ALTF.NRSITUFUNCM
                                   AND SFH.DTEFETIVA = ( SELECT MAX(DTEFETIVA) FROM GPE_SITUFUNCH
                                                         WHERE DTEFETIVA <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                                                           AND ( SFH.NRORG IS NULL OR SFH.NRORG = 0 OR SFH.NRORG = GPE_VINCULOM.NRORG )
                                                           AND NRSITUFUNCM = SFH.NRSITUFUNCM )
        LEFT JOIN GPE_MOTIVOAFASTA MA ON ( MA.NRORG = ALTF.NRORG OR MA.NRORG = 0 OR MA.NRORG IS NULL )
                                     AND MA.NRMOTIVOAFASTA = ALTF.NRMOTIVOAFASTA
                                     AND MA.IDATIVO        = 'S'
                                     
        /*alteração salarial*/
        LEFT JOIN GPE_ALTESALARIO ATS ON ATS.NRORG         = GPE_VINCULOM.NRORG
                                     AND ATS.NRVINCULOM    = GPE_VINCULOM.NRVINCULOM
                                     AND ATS.DTALTESALARIO = ( SELECT MAX(DTALTESALARIO) FROM GPE_ALTESALARIO
                                                                WHERE DTALTESALARIO <= LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                                                                  AND NRORG      = GPE_VINCULOM.NRORG
                                                                  AND NRVINCULOM = GPE_VINCULOM.NRVINCULOM )
                                     AND ATS.NROCORRENCIA  = ( SELECT MAX(NROCORRENCIA) FROM GPE_ALTESALARIO
                                                                WHERE DTALTESALARIO = ATS.DTALTESALARIO
                                                                  AND NRORG      = GPE_VINCULOM.NRORG
                                                                  AND NRVINCULOM = GPE_VINCULOM.NRVINCULOM )
                                     AND ATS.VRSALARIO     = ( SELECT MAX(VRSALARIO) FROM GPE_ALTESALARIO
                                                                WHERE DTALTESALARIO = ATS.DTALTESALARIO
                                                                  AND NROCORRENCIA  = ATS.NROCORRENCIA
                                                                  AND NRORG         = GPE_VINCULOM.NRORG
                                                                  AND NRVINCULOM    = GPE_VINCULOM.NRVINCULOM )
        LEFT JOIN FPA_TIPOMOVIMENT TM ON ( TM.NRORG = :P_NRORG OR TM.NRORG = :P_NRORG_PADRAO ) 
                                     AND TM.NRTIPOMOVIMENT = FPA_CALCULOFOLHA.NRTIPOMOVIMENT
        /*Benefícios*/
        LEFT JOIN (SELECT VAB_BENEFICIARIO.NRORG, VAB_BENEFICIARIO.NRVINCULOM, VAB_BENEFICIOM.NRBENEFICIOM, VAB_BENEFICIOH.DSBENEFICIO, TPBENEFICIO.DSTPBENEFICIO,
                          VAB_BENEFICIOH.NREVENTOMENSA, VAB_BENEFICIOH.NREVETITULARVINC, VAB_BENEFICIOH.NREVENTOCOPART, VAB_BENEFICIOH.NREVETITULAREMP,
                          VAB_BENEFICIOH.NREVENTOMENSADEP, VAB_BENEFICIOH.NREVEDEPEVINC, VAB_BENEFICIOH.NREVENTOCOPARTDEP, VAB_BENEFICIOH.NREVEDEPEMPRESA,
                          ESTRUTBENEFM.NRESTRUTURAM, ESTRUTBENEFH.NMESTRUTURAH, ESTRUTBENEFH.CDFEDERALESTRUT
                     FROM VAB_BENEFICIARIO
                     JOIN VAB_BENEFICIOM ON VAB_BENEFICIOM.NRORG = VAB_BENEFICIARIO.NRORG
                                             AND VAB_BENEFICIOM.NRBENEFICIOM = VAB_BENEFICIARIO.NRBENEFICIOM
                     JOIN VAB_BENEFICIOH ON VAB_BENEFICIOH.NRORG = VAB_BENEFICIOM.NRORG
                                        AND VAB_BENEFICIOH.NRBENEFICIOM = VAB_BENEFICIOM.NRBENEFICIOM
                                        AND VAB_BENEFICIOH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM VAB_BENEFICIOH VH2
                                                                              WHERE VH2.NRORG          = VAB_BENEFICIOH.NRORG
                                                                                AND VH2.NRBENEFICIOM   = VAB_BENEFICIOH.NRBENEFICIOM
                                                                                AND VH2.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                     JOIN TPBENEFICIO ON (TPBENEFICIO.NRORG = VAB_BENEFICIOH.NRORG OR TPBENEFICIO.NRORG = :P_NRORG_PADRAO)
                                     AND TPBENEFICIO.NRTPBENEFICIO = VAB_BENEFICIOH.NRTPBENEFICIO
                     JOIN ESTRUTURAM ESTRUTBENEFM ON ESTRUTBENEFM.NRORG = VAB_BENEFICIOH.NRORG
                                                 AND ESTRUTBENEFM.NRESTRUTURAM = VAB_BENEFICIOH.NRESTRUTURAM
                     LEFT JOIN ESTRUTURAH ESTRUTBENEFH ON ESTRUTBENEFH.NRORG = ESTRUTBENEFM.NRORG
                                                 AND ESTRUTBENEFH.NRESTRUTURAM = ESTRUTBENEFM.NRESTRUTURAM
                                                 AND ESTRUTBENEFH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                                     WHERE ESTRUTURAH.NRORG = ESTRUTBENEFH.NRORG
                                                                                       AND ESTRUTURAH.NRESTRUTURAM = ESTRUTBENEFH.NRESTRUTURAM
                                                                                       AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                    WHERE VAB_BENEFICIARIO.NRORG = :P_NRORG
                      AND (VAB_BENEFICIARIO.DTCANCBENEFICIARIO IS NULL OR VAB_BENEFICIARIO.DTCANCBENEFICIARIO > TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                      AND VAB_BENEFICIOM.DTINICIOVIGENCIA <= LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                      AND (VAB_BENEFICIOM.DTFINALVIGENCIA IS NULL OR VAB_BENEFICIOM.DTFINALVIGENCIA > TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                   ) BEN ON BEN.NRORG = GPE_VINCULOM.NRORG
                        AND BEN.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                        AND FPA_ITECALCFOLHA.NREVENTOM IN (BEN.NREVENTOMENSA, BEN.NREVETITULARVINC, BEN.NREVENTOCOPART, BEN.NREVETITULAREMP,
                                                           BEN.NREVENTOMENSADEP, BEN.NREVEDEPEVINC, BEN.NREVENTOCOPARTDEP, BEN.NREVEDEPEMPRESA)
        WHERE FPA_CALCULOFOLHA.NRORG          = :P_NRORG
          AND FPA_CALCULOFOLHA.NRTPMODALIDCAL = :P_TPMODALIDCAL
          $tipohierarquiaWhere
          $whereCalc
          $condEstrutLegal
          $condEstrutGeren
          $condEstrutSind
          $condicaoMovimento
          $generalWhere
      AND (CONTCORRPARC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC) NRCONTCORRPARC
                                      FROM CONTCORRPARC C
                                     WHERE NRORG = GPE_PESSOA.NRORG
                                       AND NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO) OR CONTCORRPARC.NRCONTCORRPARC IS NULL)
".$groupby."

/*) RES ) PRI
WHERE PRI.FLAG = PRI.FLAG2*/
ORDER BY NMESTRUTLEGAL, NMVINCULOM, NREVENTOM";

      $query = $this->entityManager->getConnection()->prepare("SELECT * FROM ($sql) FPA_CALCULOFOLHA");

      $query->execute(
        array(
          "P_DTMESCOMPETENC"  => $parameters['P_DTMESCOMPETENC'],
          "P_NRORG"           => $parameters['P_NRORG'],
          "P_TPMODALIDCAL"    => $parameters['NRTPMODALIDCAL'],
          "P_NRORG_PADRAO"    => $parameters['P_NRORG_PADRAO'],
          "P_NRTIPOESTRUTURA" => $tipoEstruturaMov
        )
      );

      return $query->fetchAll();
    }

    private function setSelectEstruturaSuperior(?string $nomeTipoEstrutura): void
    {
        $nomeTipoEstrutura = explode('\'', $nomeTipoEstrutura);
        $listaTipoEstrutura = [];

        foreach ($nomeTipoEstrutura as $index => $tipoEstrutura) {
            if ($tipoEstrutura != '' && !preg_match('/ AS /', $tipoEstrutura) == 0) {
                $tipoEstrutura = str_replace(' AS ', '', $tipoEstrutura);
                $tipoEstrutura = str_replace(',', '', $tipoEstrutura);
                $tipoEstrutura = str_replace(' ', '', $tipoEstrutura);

                $listaTipoEstrutura[] = $tipoEstrutura.'_NR';
                $listaTipoEstrutura[] = $tipoEstrutura.'_NM';
            }
        }

        $this->selectEstruturaSuperior = implode(', ', $listaTipoEstrutura) . ',';
    }

    public function selectMovimentacoes($filtroVinculo){
      if($filtroVinculo == 'N') {
            $select = "SELECT
                  $this->selectEstruturaSuperior
                   VINCULOH.NRESTRUTLEGAL,
                   ESTRUTLEGALH.NMESTRUTURAH AS NMESTRUTLEGAL,

                   VINCULOH.NRESTRUTGEREN,
                   ESTRUTGERENCH.NMESTRUTURAH AS NMESTRUTGEREN,

                   VINCULOH.NRESTRUTSIND,
                   ESTRUTSINDH.NMESTRUTURAH AS NMESTRUTSIND,

                   HIERARQUIAORG.NRTIPOHIERARQORG,
                   ESTRUTSUPERIORM.NRESTRUTURAM AS NRESTRUTSUPERIORM,
                   ESTRUTSUPERIORH.NMESTRUTURAH AS NMESTRUTSUPERIORM,

                   ESTRUTMOVIMM.NRESTRUTURAM AS NRESTRUTMOVIMM,
                   ESTRUTMOVIMH.NMESTRUTURAH AS NMESTRUTMOVIMM,

                   FPA_CALCULOFOLHA.NRTIPOMOVIMENT,
                   TM.NMTIPOMOVIMENT,
                   FPA_ITECALCFOLHA.NREVENTOM,
                   EVENTOH.NMEVENTOH,
                   FPA_ITECALCFOLHA.NRORG,
                   FPA_ITECALCFOLHA.IDEVENDEMONCALC,
                   SUM(FPA_ITECALCFOLHA.VRREFFOLHA) AS VRREFFOLHA,
                   SUM(FPA_ITECALCFOLHA.VREVENTOFOLHA) AS VREVENTOFOLHA,
                   FPA_ITECALCFOLHA.QTOCORPROXPERI,
                   FPA_ITECALCFOLHA.IDREFEVALORCALC,
                   SUBSTR(FPA_ITECALCFOLHA.DTOCORRENCIA, 1, 10) DTOCORRENCIA,
                   SUBSTR(FPA_CALCULOFOLHA.DTOCORRENCIA, 1, 10) AS DTOCORRENCIACALC,
                   FPA_EVENTOM.IDTIPOEVENTO,
                   FPA_TPEVENTOCTBL.NRTPEVENTOCTBL,
                   FPA_TPEVENTOCTBL.DSTPEVENTOCTBL,
                   MAX(FPA_EVENTOCTBL.CDCONTCTBLDEB) AS CDCONTCTBLDEB,
                   MAX(FPA_EVENTOCTBL.CDHISTPADRDEB) AS CDHISTPADRDEB,
                   MAX(FPA_EVENTOCTBL.CDCONTCTBLCRE) AS CDCONTCTBLCRE,
                   MAX(FPA_EVENTOCTBL.CDHISTPADRCRE) AS CDHISTPADRCRE,
                   MAX(FPA_EVENTOCTBL.CDDESPADMFAT) AS CDDESPADMFAT,
                   MAX(DESPADMFATUR.DSDESPADMFAT) AS DSDESPADMFAT,
                   CASE
                      WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS NOT NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS NOT NULL THEN 3
                      WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS NOT NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS     NULL THEN 2
                      WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS     NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS NOT NULL THEN 1
                      ELSE 0
                   END FLAG,
                   
                   GPE_MOTIVORESC.NRMOTIVORESC,
                   GPE_MOTIVORESC.NMMOTIVORESC,
                   
                   ESTRUTGERENCM.CDINTESTRUTEXP,
                   ESTRUTGERENCM.CDINTESTRUTEXPFIL,

                   NULL NRVINCULOM,
                   NULL NMVINCULOM,
                   NULL DTADMISSAOVINC,
                   NULL DTRESCISAOVINC,
                   NULL DTAVISOPREVIO,
                   NULL DSOBSRESCISAO,
                   NULL NRTPDEMISSAO,
                   NULL NMTPDEMISSAO,
                   NULL NRTIPOVINCULOM,
                   NULL NMTIPOVINCULOH,
                   NULL NRCPFPESSOA,
                   NULL CDAGENCIA,
                   NULL NMAGENCIA,
                   NULL CDCONTCORR,
                   NULL CDMATRICULA,
                   Null CDMATRICULAESOCIAL,
                   
                   NULL DTNASCPESSOA,
                   NULL NMOCUPACAOH,

                   NULL CDTABECDI, 
                   NULL DTINISITUFUNC,
                   NULL DTFIMSITUFUNC,
                   NULL NRMOTIVOAFASTA,
                   NULL NMMOTIVOAFASTA,
                   NULL NRSITUFUNCM,
                   NULL NMSITUFUNCH,
                   NULL VRSALARIO,
                   
                   NULL NRBENEFICIOM,
                   NULL DSBENEFICIO,
                   NULL DSTPBENEFICIO,
                   NULL NRESTRUTBENEF,
                   NULL NMESTRUTBENEF,
                   NULL CDFEDERALESTRUT,
                   FPA_ITECALCFOLHA.DTGERULTCNAB,
                   FPA_ITECALCFOLHA.DTGERULTGRRF,
                   BANCO.CDBANCO,
                   BANCO.NMBANCO ";

            $groupby = "GROUP BY
                  $this->selectEstruturaSuperior
                   VINCULOH.NRESTRUTLEGAL,
                   ESTRUTLEGALH.NMESTRUTURAH,

                   VINCULOH.NRESTRUTGEREN,
                   ESTRUTGERENCH.NMESTRUTURAH,

                   VINCULOH.NRESTRUTSIND,
                   ESTRUTSINDH.NMESTRUTURAH,

                   HIERARQUIAORG.NRTIPOHIERARQORG,
                   ESTRUTSUPERIORM.NRESTRUTURAM,
                   ESTRUTSUPERIORH.NMESTRUTURAH,

                   ESTRUTMOVIMM.NRESTRUTURAM,
                   ESTRUTMOVIMH.NMESTRUTURAH,

                   GPE_MOTIVORESC.NRMOTIVORESC,
                   GPE_MOTIVORESC.NMMOTIVORESC,
                   ESTRUTGERENCM.CDINTESTRUTEXP,
                   ESTRUTGERENCM.CDINTESTRUTEXPFIL,

                   FPA_CALCULOFOLHA.NRTIPOMOVIMENT,
                   TM.NMTIPOMOVIMENT,
                   FPA_ITECALCFOLHA.NREVENTOM,
                   EVENTOH.NMEVENTOH,
                   FPA_ITECALCFOLHA.NRORG,
                   FPA_ITECALCFOLHA.IDEVENDEMONCALC,
                   FPA_ITECALCFOLHA.QTOCORPROXPERI,
                   FPA_ITECALCFOLHA.IDREFEVALORCALC,
                   SUBSTR(FPA_ITECALCFOLHA.DTOCORRENCIA, 1, 10),
                   SUBSTR(FPA_CALCULOFOLHA.DTOCORRENCIA, 1, 10),
                   FPA_EVENTOM.IDTIPOEVENTO,

                   FPA_TPEVENTOCTBL.NRTPEVENTOCTBL,
                   FPA_TPEVENTOCTBL.DSTPEVENTOCTBL,

                   CASE
                      WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS NOT NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS NOT NULL THEN 3
                      WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS NOT NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS     NULL THEN 2
                      WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS     NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS NOT NULL THEN 1
                      ELSE 0
                   END,
                   FPA_ITECALCFOLHA.DTGERULTCNAB,
                   FPA_ITECALCFOLHA.DTGERULTGRRF,
                   BANCO.CDBANCO,
                   BANCO.NMBANCO";
        }
        else{
            $select = "SELECT
                  $this->selectEstruturaSuperior
                   REPLACE( TRANSLATE (GPE_VINCULOM.CDMATRICULA, '~!@#$%^&*_-+=|\(){}[]:;<>,.?/' , ' ' ), ' ', '' ) CDMATRICULA,
                   VINCULOH.CDMATRICULAESOCIAL,
                   VINCULOH.NRESTRUTLEGAL,
                   ESTRUTLEGALH.NMESTRUTURAH AS NMESTRUTLEGAL,

                   VINCULOH.NRESTRUTGEREN,
                   ESTRUTGERENCH.NMESTRUTURAH AS NMESTRUTGEREN,

                   VINCULOH.NRESTRUTSIND,
                   ESTRUTSINDH.NMESTRUTURAH AS NMESTRUTSIND,

                   HIERARQUIAORG.NRTIPOHIERARQORG,
                   ESTRUTSUPERIORM.NRESTRUTURAM AS NRESTRUTSUPERIORM,
                   ESTRUTSUPERIORH.NMESTRUTURAH AS NMESTRUTSUPERIORM,

                   ESTRUTMOVIMM.NRESTRUTURAM AS NRESTRUTMOVIMM,
                   ESTRUTMOVIMH.NMESTRUTURAH AS NMESTRUTMOVIMM,

                   GPE_MOTIVORESC.NRMOTIVORESC,
                   GPE_MOTIVORESC.NMMOTIVORESC,

                   FPA_CALCULOFOLHA.NRTIPOMOVIMENT,
                   TM.NMTIPOMOVIMENT,
                   FPA_ITECALCFOLHA.NRITEMCALCFOLHA,
                   FPA_ITECALCFOLHA.NRCALCULOFOLHA,

                   FPA_ITECALCFOLHA.NRVINCULOM,
                   GPE_VINCULOM.NMVINCULOM,
                   GPE_VINCULOM.DTADMISSAOVINC,

                   GPE_VINCULOM.NRTPADMISSAO,
                   FPA_TPADMISSAO.NMTPADMISSAO,
                   GPE_VINCULOM.NRTPAVIPRE,
                   SUBSTR(GPE_VINCULOM.DTRESCISAOVINC, 1, 10) DTRESCISAOVINC,
                   SUBSTR(GPE_VINCULOM.DTAVISOPREVIO, 1, 10) DTAVISOPREVIO,
                   GPE_VINCULOM.DSOBSRESCISAO,
                   FPA_TPDEMISSAO.NRTPDEMISSAO,
                   FPA_TPDEMISSAO.NMABREV AS NMTPDEMISSAO,

                   FPA_ITECALCFOLHA.NREVENTOM,
                   EVENTOH.NMEVENTOH ,
                   FPA_ITECALCFOLHA.NRORG,
                   FPA_ITECALCFOLHA.IDEVENDEMONCALC,
                   FPA_ITECALCFOLHA.VRREFFOLHA,
                   FPA_ITECALCFOLHA.VREVENTOFOLHA,
                   FPA_ITECALCFOLHA.QTOCORPROXPERI,
                   FPA_ITECALCFOLHA.IDREFEVALORCALC,
                   SUBSTR(FPA_ITECALCFOLHA.DTOCORRENCIA, 1, 10) DTOCORRENCIA,
                   SUBSTR(FPA_CALCULOFOLHA.DTOCORRENCIA, 1, 10) AS DTOCORRENCIACALC,
                   EVENTOH.NREVENTOH,
                   FPA_EVENTOM.IDTIPOEVENTO,
                   GPE_VINCULOM.NRTIPOVINCULOM,
                   GVH.NMTIPOVINCULOH,
                   GPE_PESSOAH.NRCPFPESSOA,
                   ESTRUTGERENCM.CDINTESTRUTEXP,
                   ESTRUTGERENCM.CDINTESTRUTEXPFIL,
                   BANCO.CDBANCO,
                   BANCO.NMBANCO,
                   CONTCORRPARC.CDAGENCIA,
                   AGENCIA.NMAGENCIA,
                   CONTCORRPARC.CDCONTCORR,
                   FPA_TPEVENTOCTBL.NRTPEVENTOCTBL,
                   FPA_TPEVENTOCTBL.DSTPEVENTOCTBL,
                   MAX(FPA_EVENTOCTBL.CDCONTCTBLDEB) AS CDCONTCTBLDEB,
                   MAX(FPA_EVENTOCTBL.CDHISTPADRDEB) AS CDHISTPADRDEB,
                   MAX(FPA_EVENTOCTBL.CDCONTCTBLCRE) AS CDCONTCTBLCRE,
                   MAX(FPA_EVENTOCTBL.CDHISTPADRCRE) AS CDHISTPADRCRE,
                   MAX(FPA_EVENTOCTBL.CDDESPADMFAT) AS CDDESPADMFAT,
                   MAX(DESPADMFATUR.DSDESPADMFAT) AS DSDESPADMFAT,
                   CASE
                      WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS NOT NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS NOT NULL THEN 3
                      WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS NOT NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS     NULL THEN 2
                      WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS     NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS NOT NULL THEN 1
                      ELSE 0
                   END FLAG,
                   
                   GPE_PESSOAH.DTNASCPESSOA,
                   GPE_OCUPACAOH.NMOCUPACAOH,

                   ALTF.CDTABECDI, 
                   ALTF.DTINISITUFUNC,
                   ALTF.DTFIMSITUFUNC,
                   MA.NRMOTIVOAFASTA,
                   MA.NMMOTIVOAFASTA,
                   SFH.NRSITUFUNCM,
                   SFH.NMSITUFUNCH,
                   ATS.VRSALARIO,
                   
                   BEN.NRBENEFICIOM,
                   BEN.DSBENEFICIO,
                   BEN.DSTPBENEFICIO,
                   BEN.NRESTRUTURAM AS NRESTRUTBENEF,
                   BEN.NMESTRUTURAH AS NMESTRUTBENEF,
                   BEN.CDFEDERALESTRUT,
                   FPA_ITECALCFOLHA.DTGERULTCNAB,
                   FPA_ITECALCFOLHA.DTGERULTGRRF ";

            $groupby = "GROUP BY
                      $this->selectEstruturaSuperior
                       GPE_VINCULOM.CDMATRICULA,
                       VINCULOH.CDMATRICULAESOCIAL,
                       VINCULOH.NRESTRUTLEGAL,
                       ESTRUTLEGALH.NMESTRUTURAH,

                       VINCULOH.NRESTRUTGEREN,
                       ESTRUTGERENCH.NMESTRUTURAH,

                       VINCULOH.NRESTRUTSIND,
                       ESTRUTSINDH.NMESTRUTURAH,

                       HIERARQUIAORG.NRTIPOHIERARQORG,
                       ESTRUTSUPERIORM.NRESTRUTURAM,
                       ESTRUTSUPERIORH.NMESTRUTURAH,

                       ESTRUTMOVIMM.NRESTRUTURAM,
                       ESTRUTMOVIMH.NMESTRUTURAH,

                       GPE_MOTIVORESC.NRMOTIVORESC,
                       GPE_MOTIVORESC.NMMOTIVORESC,

                       FPA_CALCULOFOLHA.NRTIPOMOVIMENT,
                       TM.NMTIPOMOVIMENT,
                       FPA_ITECALCFOLHA.NRITEMCALCFOLHA,
                       FPA_ITECALCFOLHA.NRCALCULOFOLHA,
                       
                       FPA_ITECALCFOLHA.NRVINCULOM,
                       GPE_VINCULOM.NMVINCULOM,
                       GPE_VINCULOM.DTADMISSAOVINC,

                       GPE_VINCULOM.NRTPADMISSAO,
                       FPA_TPADMISSAO.NMTPADMISSAO,
                       GPE_VINCULOM.NRTPAVIPRE,
                       SUBSTR(GPE_VINCULOM.DTRESCISAOVINC, 1, 10),
                       SUBSTR(GPE_VINCULOM.DTAVISOPREVIO, 1, 10),
                       GPE_VINCULOM.DSOBSRESCISAO,
                       FPA_TPDEMISSAO.NRTPDEMISSAO,
                       FPA_TPDEMISSAO.NMABREV,

                       FPA_ITECALCFOLHA.NREVENTOM,
                       EVENTOH.NMEVENTOH,
                       FPA_ITECALCFOLHA.NRORG,
                       FPA_ITECALCFOLHA.IDEVENDEMONCALC,
                       FPA_ITECALCFOLHA.VRREFFOLHA,
                       FPA_ITECALCFOLHA.VREVENTOFOLHA,
                       FPA_ITECALCFOLHA.QTOCORPROXPERI,
                       FPA_ITECALCFOLHA.IDREFEVALORCALC,
                       SUBSTR(FPA_ITECALCFOLHA.DTOCORRENCIA, 1, 10),
                       SUBSTR(FPA_CALCULOFOLHA.DTOCORRENCIA, 1, 10),
                       EVENTOH.NREVENTOH,
                       FPA_EVENTOM.IDTIPOEVENTO,
                       GPE_VINCULOM.NRTIPOVINCULOM,
                       GVH.NMTIPOVINCULOH,
                       GPE_PESSOAH.NRCPFPESSOA,
                       ESTRUTGERENCM.CDINTESTRUTEXP,
                       ESTRUTGERENCM.CDINTESTRUTEXPFIL,
                       BANCO.CDBANCO,
                       BANCO.NMBANCO,
                       CONTCORRPARC.CDAGENCIA,
                       AGENCIA.NMAGENCIA,
                       CONTCORRPARC.CDCONTCORR,
                       FPA_TPEVENTOCTBL.NRTPEVENTOCTBL,
                       FPA_TPEVENTOCTBL.DSTPEVENTOCTBL,
                       DESPADMFATUR.DSDESPADMFAT,
    
                       CASE
                          WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS NOT NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS NOT NULL THEN 3
                          WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS NOT NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS     NULL THEN 2
                          WHEN FPA_EVENTOCTBL.NRESTRUTURAM IS     NULL AND FPA_EVENTOCTBL.NRTPEVENTOCTBL IS NOT NULL THEN 1
                          ELSE 0
                       END,

                       GPE_PESSOAH.DTNASCPESSOA,
                       GPE_OCUPACAOH.NMOCUPACAOH,

                       ALTF.CDTABECDI,
                       ALTF.DTINISITUFUNC,
                       ALTF.DTFIMSITUFUNC,
                       MA.NRMOTIVOAFASTA,
                       MA.NMMOTIVOAFASTA,
                       SFH.NRSITUFUNCM,
                       SFH.NMSITUFUNCH,
                       ATS.VRSALARIO,
                   
                       BEN.NRBENEFICIOM,
                       BEN.DSBENEFICIO,
                       BEN.DSTPBENEFICIO,
                       BEN.NRESTRUTURAM,
                       BEN.NMESTRUTURAH,
                       BEN.CDFEDERALESTRUT,
                       FPA_ITECALCFOLHA.DTGERULTCNAB,
                       FPA_ITECALCFOLHA.DTGERULTGRRF ";
        }
        return array($select, $groupby);
    }

    public function getRelatCustomMovimentacaoEventos($parameters, $filters){
      $generalWhere = self::getWhereFilters($filters);
      if(array_key_exists('NRTIPOHIERARQORG', $parameters)) {
          $tipohierarquia = $parameters['NRTIPOHIERARQORG'];
          $tipohierarquia = "AND (HIERARQUIAORG.NRTIPOHIERARQORG = $tipohierarquia OR HIERARQUIAORG.NRTIPOHIERARQORG IS NULL)";
      }else{
          $tipohierarquia =  "AND 1 = 2";
      }

      self::initPivotElements($parameters);
      if(array_key_exists('NRESTRUTLEGAL', $parameters)) {
          $listEstrutLegal = array_map(function($estrutlegal) {
              return $estrutlegal;
          },
          $parameters['NRESTRUTLEGAL']);
          $condEstrutLegal = "AND VINCULOH.NRESTRUTLEGAL IN (" . implode(',',$listEstrutLegal) . ")";
      } else {
        $condEstrutLegal = "";
      }
       

      if(array_key_exists('NRESTRUTGEREN', $parameters)) {
          $listEstrutGeren = array_map(function($estrutgeren) {
              return $estrutgeren;
          },
          $parameters['NRESTRUTGEREN']);
          $condEstrutGeren = "AND VINCULOH.NRESTRUTGEREN IN (" . implode(',',$listEstrutGeren) . ")";
      } else {
        $condEstrutGeren = "";
      }

      if(array_key_exists('NRESTRUTSIND', $parameters)) {
          $listEstrutSind = array_map(function($estrutsind) {
              return $estrutsind;
          },
          $parameters['NRESTRUTSIND']);
          $condEstrutSind = "AND VINCULOH.NRESTRUTSIND IN (" . implode(',',$listEstrutSind) . ")";
      } else {
        $condEstrutSind = "";
      }

      if(array_key_exists('NRESTRUTSUPERIORM', $parameters)) {
          if(is_string($parameters['NRESTRUTSUPERIORM'])) $parameters['NRESTRUTSUPERIORM'] = explode(',', $parameters['NRESTRUTSUPERIORM']);
          $listEstrutSuperior = array_map(function($estrutsup) {
              return $estrutsup;
          },
          $parameters['NRESTRUTSUPERIORM']);
          $condEstrutSuper = "AND ESTRUTSUPERIORM.NRESTRUTURAM IN (" . implode(',',$listEstrutSuperior) . ")";
      } else {
        $condEstrutSuper = "";
      }
      
      $dtOcorrencia = '';
      if(array_key_exists('DTOCORRENCIA', $parameters)){
          $dtOcorrencia = " AND FPA_CALCULOFOLHA.DTOCORRENCIA BETWEEN '".$parameters['DTOCORRENCIA'][0]."' AND '".$parameters['DTOCORRENCIA'][1]."' ";
      }else{
          $dtOcorrencia = " AND FPA_CALCULOFOLHA.DTOCORRENCIA = :P_DTMESCOMPETENC ";
      }


      if(array_key_exists('NREVENTOM', $parameters)) {
          if(is_string($parameters['NREVENTOM'])) $parameters['NREVENTOM'] = explode(',', $parameters['NREVENTOM']);
          $listNrEventom = array_map(function($estrutgeren) {
              return $estrutgeren;
          },
          $parameters['NREVENTOM']);
          $condNrEventom = "AND FPA_EVENTOM.NREVENTOM IN (" . implode(',',$listNrEventom) . ")";
      } else {
        $condNrEventom = "";
      }
      
      $sql = "
SELECT NRESTRUTLEGAL,
                   NMESTRUTLEGAL,

                   NRESTRUTGEREN,
                   NMESTRUTGEREN,

                   NRESTRUTSIND,
                   NMESTRUTSIND,

                   TIPOHIERARQORG,
                   NRESTRUTSUPERIORM,
                   NMESTRUTSUPERIORM,

                   NREVENTO1 AS NREVENTOM,
                   NMEVENTOH,

                   NRVINCULOM,
                   NMVINCULOM,
                   DTADMISSAOVINC,
                   DTOCORRENCIA,

                   NMSITUFUNCH,
                   DTINISITUFUNC,
                   DTFIMSITUFUNC,

                   NRCPFPESSOA,
                   DTNASCPESSOA,
                   NRTIPOVINCULOM,
                   NMTIPOVINCULOH,

                   CDINTESTRUTEXP,

                   CDBANCO,
                   NMBANCO,
                   CDAGENCIA,
                   CDCONTCORR,
                   CDMATRICULA,

                   NRORG".self::$pivotSELECTelements."

            FROM (SELECT VINCULOH.NRESTRUTLEGAL,
                         ESTRUTLEGALH.NMESTRUTURAH AS NMESTRUTLEGAL,

                         VINCULOH.NRESTRUTGEREN,
                         ESTRUTGERENCH.NMESTRUTURAH AS NMESTRUTGEREN,

                         VINCULOH.NRESTRUTSIND,
                         ESTRUTSINDH.NMESTRUTURAH AS NMESTRUTSIND,

                         HIERARQUIAORG.NRTIPOHIERARQORG AS TIPOHIERARQORG,
                         ESTRUTSUPERIORM.NRESTRUTURAM AS NRESTRUTSUPERIORM,
                         ESTRUTSUPERIORH.NMESTRUTURAH AS NMESTRUTSUPERIORM,
                        
                         EVENTOH.NREVENTOM AS NREVENTO1,
                         EVENTOH.NMEVENTOH,

                         GPE_VINCULOM.NMVINCULOM AS NMVINCULOM,
                         GPE_VINCULOM.DTADMISSAOVINC AS DTADMISSAOVINC,

                         FPA_EVENTOM.NREVENTOM,
                         FPA_ITECALCFOLHA.NRVINCULOM,
                         FPA_ITECALCFOLHA.NRORG,
                         FPA_ITECALCFOLHA.VREVENTOFOLHA,

                         FPA_CALCULOFOLHA.DTOCORRENCIA,

                         SFH.NMSITUFUNCH,
                         ALTF.DTINISITUFUNC,
                         ALTF.DTFIMSITUFUNC,

                        GPE_VINCULOM.NRTIPOVINCULOM AS NRTIPOVINCULOM,
                        GPE_PESSOAH.NRCPFPESSOA,
                        GPE_PESSOAH.DTNASCPESSOA,
                        ESTRUTGERENCM.CDINTESTRUTEXP,
                        ESTRUTGERENCM.CDINTESTRUTEXPFIL,
                         BANCO.CDBANCO,
                         BANCO.NMBANCO AS NMBANCO,
                         AGENCIA.CDAGENCIA,
                         CDCONTCORR,
                         GVH.NMTIPOVINCULOH AS NMTIPOVINCULOH,
                         REPLACE( TRANSLATE (GPE_VINCULOM.CDMATRICULA, '~!@#$%^&*_-+=|\(){}[]:;<>,.?/' , ' ' ), ' ', '' ) CDMATRICULA

                         FROM FPA_CALCULOFOLHA

                         JOIN  FPA_ITECALCFOLHA
                           ON  FPA_ITECALCFOLHA.NRORG             = FPA_CALCULOFOLHA.NRORG
                          AND  FPA_ITECALCFOLHA.NRCALCULOFOLHA    = FPA_CALCULOFOLHA.NRCALCULOFOLHA

                         JOIN FPA_EVENTOM
                           ON  (FPA_EVENTOM.NRORG        = FPA_ITECALCFOLHA.NRORG OR FPA_EVENTOM.NRORG = :P_NRORG_PADRAO)
                          AND (FPA_EVENTOM.NREVENTOM     = FPA_ITECALCFOLHA.NREVENTOM)

                         JOIN FPA_EVENTOH EVENTOH
                           ON  (FPA_EVENTOM.NRORG           = EVENTOH.NRORG OR FPA_EVENTOM.NRORG = :P_NRORG_PADRAO)
                          AND (FPA_EVENTOM.NREVENTOM        = EVENTOH.NREVENTOM
                          AND EVENTOH.DTMESCOMPETENC        =
                             (SELECT MAX(DTMESCOMPETENC)
                                FROM FPA_EVENTOH
                               WHERE NRORG             = EVENTOH.NRORG
                                 AND NREVENTOM         = EVENTOH.NREVENTOM
                                 AND DTMESCOMPETENC   <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')))

                         JOIN GPE_VINCULOM
                           ON (GPE_VINCULOM.NRORG         = FPA_ITECALCFOLHA.NRORG
                          AND GPE_VINCULOM.NRVINCULOM     = FPA_ITECALCFOLHA.NRVINCULOM)

                         JOIN GPE_VINCULOH VINCULOH
                           ON (GPE_VINCULOM.NRORG           = VINCULOH.NRORG
                          AND  GPE_VINCULOM.NRVINCULOM      = VINCULOH.NRVINCULOM)
                          AND  VINCULOH.DTMESCOMPETENC      =
                              (SELECT MAX(DTMESCOMPETENC)
                                 FROM GPE_VINCULOH
                                WHERE NRORG              = VINCULOH.NRORG
                                  AND NRVINCULOM         = VINCULOH.NRVINCULOM
                                  AND DTMESCOMPETENC    <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                          LEFT JOIN GPE_TIPOVINCULOM 
                                 ON GPE_TIPOVINCULOM.NRTIPOVINCULOM = GPE_VINCULOM.NRTIPOVINCULOM
                                AND GPE_TIPOVINCULOM.NRORG = :P_NRORG_PADRAO
                          LEFT JOIN GPE_TIPOVINCULOH GVH
                                 ON GVH.NRTIPOVINCULOM = GPE_TIPOVINCULOM.NRTIPOVINCULOM
                                AND GVH.NRORG = GPE_TIPOVINCULOM.NRORG
                                AND GVH.DTMESCOMPETENC =
                                     (SELECT MAX(DTMESCOMPETENC)
                                        FROM GPE_TIPOVINCULOH 
                                       WHERE NRORG           = GVH.NRORG
                                         AND NRTIPOVINCULOM  = GVH.NRTIPOVINCULOM
                                         AND DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))

                          LEFT JOIN GPE_ALTESITUFUNC ALTF ON ALTF.NRORG      = GPE_VINCULOM.NRORG
                                                           AND ALTF.NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                                                           AND ALTF.DTINISITUFUNC = ( SELECT MAX(DTINISITUFUNC) FROM GPE_ALTESITUFUNC
                                                                                      WHERE DTINISITUFUNC <= LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
                                                                                        AND NRORG      = ALTF.NRORG
                                                                                        AND NRVINCULOM = ALTF.NRVINCULOM )
                          LEFT JOIN GPE_SITUFUNCH SFH ON ( SFH.NRORG IS NULL OR SFH.NRORG = 0 OR SFH.NRORG = GPE_VINCULOM.NRORG )
                                                       AND SFH.NRSITUFUNCM = ALTF.NRSITUFUNCM
                                                       AND SFH.DTEFETIVA = ( SELECT MAX(DTEFETIVA) FROM GPE_SITUFUNCH
                                                                             WHERE DTEFETIVA <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                                                                               AND ( SFH.NRORG IS NULL OR SFH.NRORG = 0 OR SFH.NRORG = GPE_VINCULOM.NRORG )
                                                                               AND NRSITUFUNCM = SFH.NRSITUFUNCM )


                         LEFT JOIN ESTRUTURAM ESTRUTLEGALM
                           ON (VINCULOH.NRORG         = ESTRUTLEGALM.NRORG
                          AND  VINCULOH.NRESTRUTLEGAL = ESTRUTLEGALM.NRESTRUTURAM)

                         LEFT JOIN ESTRUTURAH ESTRUTLEGALH
                           ON (ESTRUTLEGALM.NRORG           = ESTRUTLEGALH.NRORG
                          AND  ESTRUTLEGALM.NRESTRUTURAM    = ESTRUTLEGALH.NRESTRUTURAM
                          AND  ESTRUTLEGALH.DTMESCOMPETENC  =
                              (SELECT MAX(DTMESCOMPETENC)
                                 FROM ESTRUTURAH
                                WHERE NRORG             = ESTRUTLEGALH.NRORG
                                  AND NRESTRUTURAM      = ESTRUTLEGALH.NRESTRUTURAM
                                  AND DTMESCOMPETENC   <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')))

                         LEFT JOIN ESTRUTURAM ESTRUTGERENCM
                           ON (VINCULOH.NRORG         = ESTRUTGERENCM.NRORG
                          AND  VINCULOH.NRESTRUTGEREN = ESTRUTGERENCM.NRESTRUTURAM)

                         LEFT JOIN ESTRUTURAH ESTRUTGERENCH
                           ON (ESTRUTGERENCM.NRORG           = ESTRUTGERENCH.NRORG
                          AND  ESTRUTGERENCM.NRESTRUTURAM    = ESTRUTGERENCH.NRESTRUTURAM
                          AND  ESTRUTGERENCH.DTMESCOMPETENC  =
                              (SELECT MAX(DTMESCOMPETENC)
                                 FROM ESTRUTURAH
                                WHERE NRORG             = ESTRUTGERENCH.NRORG
                                  AND NRESTRUTURAM      = ESTRUTGERENCH.NRESTRUTURAM
                                  AND DTMESCOMPETENC   <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')))

                         LEFT JOIN ESTRUTURAM ESTRUTSINDM
                           ON (VINCULOH.NRORG         = ESTRUTSINDM.NRORG
                          AND  VINCULOH.NRESTRUTSIND  = ESTRUTSINDM.NRESTRUTURAM)

                         LEFT JOIN ESTRUTURAH ESTRUTSINDH
                           ON (ESTRUTSINDM.NRORG           = ESTRUTSINDH.NRORG
                          AND  ESTRUTSINDM.NRESTRUTURAM    = ESTRUTSINDH.NRESTRUTURAM
                          AND  ESTRUTSINDH.DTMESCOMPETENC  =
                              (SELECT MAX(DTMESCOMPETENC)
                                 FROM ESTRUTURAH
                                WHERE NRORG             = ESTRUTSINDH.NRORG
                                  AND NRESTRUTURAM      = ESTRUTSINDH.NRESTRUTURAM
                                  AND DTMESCOMPETENC   <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')))
                         JOIN GPE_PESSOA
                             ON GPE_VINCULOM.NRPESSOA = GPE_PESSOA.NRPESSOA
                            AND GPE_VINCULOM.NRORG = GPE_PESSOA.NRORG

                         JOIN GPE_PESSOAH
                             ON GPE_PESSOAH.NRPESSOA = GPE_PESSOA.NRPESSOA
                            AND GPE_PESSOAH.NRORG = GPE_PESSOA.NRORG
                            AND GPE_PESSOAH.DTMESCOMPETENC = (SELECT MAX(MAX_PESSOAH.DTMESCOMPETENC)
                                 FROM GPE_PESSOAH MAX_PESSOAH
                                 WHERE MAX_PESSOAH.NRPESSOA = GPE_PESSOAH.NRPESSOA
                                   AND MAX_PESSOAH.NRORG = GPE_PESSOAH.NRORG
                                   AND MAX_PESSOAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))

                        LEFT JOIN CONTCORRPARC
                               ON CONTCORRPARC.NRORG = GPE_VINCULOM.NRORG
                              AND CONTCORRPARC.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
                        LEFT JOIN BANCO
                               ON BANCO.CDBANCO = CONTCORRPARC.CDBANCO
                              AND (BANCO.NRORG = GPE_VINCULOM.NRORG OR BANCO.NRORG = :P_NRORG_PADRAO)
                        LEFT JOIN AGENCIA
                               ON AGENCIA.CDAGENCIA = CONTCORRPARC.CDAGENCIA
                              AND AGENCIA.CDBANCO   = CONTCORRPARC.CDBANCO
                              AND (AGENCIA.NRORG = GPE_VINCULOM.NRORG OR AGENCIA.NRORG = :P_NRORG_PADRAO)
                        LEFT JOIN HIERARQUIAORG
                               ON HIERARQUIAORG.NRESTRUTURAMREL  = VINCULOH.NRESTRUTGEREN
                              AND HIERARQUIAORG.NRORG            = GPE_VINCULOM.NRORG
                              
                              $tipohierarquia
                              
                        LEFT JOIN ESTRUTURAM ESTRUTSUPERIORM
                               ON (VINCULOH.NRORG         = ESTRUTSUPERIORM.NRORG
                              AND  HIERARQUIAORG.NRESTRUTURAMSUP = ESTRUTSUPERIORM.NRESTRUTURAM)
                        LEFT JOIN ESTRUTURAH ESTRUTSUPERIORH
                               ON (ESTRUTSUPERIORM.NRORG        = ESTRUTSUPERIORH.NRORG
                              AND  ESTRUTSUPERIORM.NRESTRUTURAM = ESTRUTSUPERIORH.NRESTRUTURAM)
                              AND  ESTRUTSUPERIORH.DTMESCOMPETENC =
                                                                     (SELECT MAX(DTMESCOMPETENC)
                                                                FROM ESTRUTURAH
                                                               WHERE ESTRUTURAH.NRORG            = ESTRUTSUPERIORH.NRORG
                                                                 AND ESTRUTURAH.NRESTRUTURAM       = ESTRUTSUPERIORH.NRESTRUTURAM
                                                                 AND ESTRUTURAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))



                         WHERE FPA_CALCULOFOLHA.NRORG           = :P_NRORG
                            AND FPA_CALCULOFOLHA.DTOCORRENCIA = :P_DTMESCOMPETENC 
                           AND (CONTCORRPARC.NRCONTCORRPARC = ( SELECT MAX(NRCONTCORRPARC) NRCONTCORRPARC
                                      FROM CONTCORRPARC C
                                     WHERE NRORG = GPE_PESSOA.NRORG
                                       AND NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO) OR CONTCORRPARC.NRCONTCORRPARC IS NULL)
                            $generalWhere
                            $condEstrutLegal
                            $condEstrutGeren
                            $condEstrutSind
                            $condEstrutSuper
                            $dtOcorrencia
                            $condNrEventom

                        ) PIVOT ( SUM(VREVENTOFOLHA) FOR NREVENTOM IN (".self::$pivotINelements.")) res      
      ";
      
      $query = $this->entityManager->getConnection()->prepare($sql);
        
      $query->execute(
        array(
          "P_DTMESCOMPETENC"  => $parameters['P_DTMESCOMPETENC'],
          "P_NRORG"        => $parameters['P_NRORG'],
          "P_NRORG_PADRAO" => $parameters['P_NRORG_PADRAO']
        )
      );

      return $query->fetchAll();
    }

    public static function initPivotElements($parameters) {

        /*$whereClause =  "
            NREVENTOM    = 10           OR
            NREVENTOM    = 140          OR
            NREVENTOM    = 210          OR
            NREVENTOM    = 230          OR
            NREVENTOM    = 300          OR
            NREVENTOM    = 947          OR
            NREVENTOM    = 970          OR
            NREVENTOM    = 990          OR
            NREVENTOM    = 2010         OR
            NREVENTOM    = 100000       OR
            NREVENTOM    = 100002       OR
            NREVENTOM    = 100015       OR

            NREVENTOM    = 1040         OR
            NREVENTOM    = 1041         OR
            NREVENTOM    = 1060         OR
            NREVENTOM    = 1080         OR
            NREVENTOM    = 1130         OR
            NREVENTOM    = 1250         OR
            NREVENTOM    = 1290         OR
            NREVENTOM    = 1330         OR
            NREVENTOM    = 1510         OR

            NREVENTOM    = 3010         OR
            NREVENTOM    = 3020         OR
            NREVENTOM    = 3030         OR
            NREVENTOM    = 3040         OR
            NREVENTOM    = 3060         OR
            NREVENTOM    = 3070         OR
            NREVENTOM    = 3080         OR
            NREVENTOM    = 3601         OR
            NREVENTOM    = 3580";*/
            
        $whereClause = "
            (NRORG = :P_NRORG OR NRORG = 0) AND
            NREVENTOM IN (" . $parameters['NREVENTOM'] . ") AND
            DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM FPA_EVENTOH H1
                               WHERE H1.NRORG = e.NRORG
                                 AND H1.NREVENTOM = e.NREVENTOM
                                 AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENCIA)
        ";
        
        $params = array(
            'P_NRORG' => $parameters['P_NRORG'],
            'P_DTMESCOMPETENCIA' => $parameters['P_DTMESCOMPETENC']
        );

        $elements = \Folha\Entities\FpaEventoh::getObjectsByWhere($whereClause, $params, "NREVENTOM");
        
        self::$pivotINelements = '';
        self::$pivotSELECTelements = '';

        $count = 0;

        /** @var $element FpaEventoh **/
        foreach($elements as $element) {
            self::$pivotINelements     = self::$pivotINelements.$element->getNreventom()." AS EVENTO_".$count.", ";
            self::$pivotSELECTelements = self::$pivotSELECTelements.", NVL(TO_CHAR(EVENTO_".$count."), '') AS EVENTO_".$count;
            $count++;
        }

        self::$pivotINelements = substr(self::$pivotINelements, 0, -2);
      }
      
      
    public function getWhereFilters($filters) {
        $whereFilter = " ";
        foreach ($filters as $filter) {
            if($filter['columnName']=='NRESTRUTSUPERIORM'){
                if(is_array($filter['value'])){
                    $arrayEstrutSuperiorM = implode(',',$filter['value']);
                    $whereFilter .= "AND ESTRUTSUPERIORM.NRESTRUTURAM IN ($arrayEstrutSuperiorM)";
                } else {
                    $whereFilter .= "AND ESTRUTSUPERIORM.NRESTRUTURAM = '".$filter['value']."' ";
                }
            }
            else if($filter['columnName']=='NRVINCULOM' && !is_array($filter['value']))
            $whereFilter .= " AND FPA_ITECALCFOLHA.NRVINCULOM = ".$filter['value']." ";
            else if($filter['columnName']=='NRTIPOVINCULOM')
            $whereFilter .= " AND GPE_VINCULOM.NRTIPOVINCULOM = ".$filter['value']." ";
            else if($filter['columnName']=='IDEVENDEMONCALC')
            $whereFilter .= " AND FPA_ITECALCFOLHA.IDEVENDEMONCALC = '".$filter['value']."' ";
            else if($filter['columnName']=='DTAVISOPREVIO')
            $whereFilter .= " AND GPE_VINCULOM.DTAVISOPREVIO = '".$filter['value']."' ";
            else if($filter['columnName']=='NRTPDEMISSAO')
            $whereFilter .= " AND FPA_TPDEMISSAO.NRTPDEMISSAO = '".$filter['value']."' ";
            else if($filter['columnName']=='NRMOTIVORESC')
            $whereFilter .= " AND GPE_MOTIVORESC.NRMOTIVORESC = '".$filter['value']."' ";
            else if($filter['columnName']=='NRMOTIVOAFASTA')
            $whereFilter .= " AND MA.NRMOTIVOAFASTA = '".$filter['value']."' ";
            else if($filter['columnName']=='IDTIPOEVENTO')
            $whereFilter .= " AND FPA_EVENTOM.IDTIPOEVENTO = '".$filter['value']."' ";
            else if($filter['columnName']=='IDREFEVALORCALC')
            $whereFilter .= " AND FPA_ITECALCFOLHA.IDREFEVALORCALC = '".$filter['value']."' ";
            else if($filter['columnName']=='NRSITUFUNCM')
            $whereFilter .= " AND SFH.NRSITUFUNCM = '".$filter['value']."' ";
            else if($filter['columnName']=='DTRESCISAOVINC')
            $whereFilter .= " AND GPE_VINCULOM.DTRESCISAOVINC = '".$filter['value']."' ";
            else if($filter['columnName']=='CDBANCO')
            $whereFilter .= " AND BANCO.CDBANCO = '".$filter['value']."' ";
            else if($filter['columnName']=='CDAGENCIA')
            $whereFilter .= " AND CONTCORRPARC.CDAGENCIA = '".$filter['value']."' ";
        }
        return $whereFilter;
        
    }

    public function getNomeTipoEstrutura($params): Array
    {
        $query = $this->entityManager->getConnection()->prepare(
            "SELECT LISTAGG('''' || NMTIPOESTRUTURA || ''' AS ' || REPLACE(NMTIPOESTRUTURA,' ','_'), ', ') WITHIN GROUP (ORDER BY NMTIPOESTRUTURA) NMTIPOESTRUTURA
           FROM (SELECT DISTINCT TPE.NMTIPOESTRUTURA
                   FROM HIERARQUIAORG H
                   JOIN TIPOHIERARQORG TP ON TP.NRTIPOHIERARQORG = H.NRTIPOHIERARQORG
                   JOIN TIPOESTRUTURA TPE ON TPE.NRTIPOESTRUTURA = TP.NRTIPOESTRUTSUP
                  WHERE H.NRORG = :P_NRORG
                    AND ( INSTR(','||:P_NRTIPOHIERARQORG||',', ','||H.NRTIPOHIERARQORG||',') > 0 OR :P_NRTIPOHIERARQORG IS NULL )
                    AND ( INSTR(','||:P_NRTIPOESTRUTURA||',', ','||TPE.NRTIPOESTRUTURA||',') > 0 OR :P_NRTIPOESTRUTURA IS NULL )
                    AND H.DTINIVIGENCIA    = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG
                                                WHERE DTINIVIGENCIA <= LAST_DAY(:P_DTMESCOMPETENC) 
                                                  AND NRORG            = H.NRORG
                                                  AND NRESTRUTURAMREL  = H.NRESTRUTURAMREL
                                                  AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ))");

        $query->execute($params);
        return $query->fetchAll();
    }
    
}