<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;

class RateioLancamentoVinculoService {
    
    protected $entityManager;
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function buscaRateioExistente($nrorg, $inicioVigencia) {
        $sql = $this->entityManager->getConnection()->prepare(
        "SELECT * FROM FPA_RATEIOVINC WHERE (NRORG = :P_NRORG AND DTINIVIGENCIA = :P_DTINIVIGENCIA)"
        );
        
        $sql->execute(
            array(
                'P_NRORG' => $nrorg,
                'P_DTINIVIGENCIA' => $inicioVigencia
            )
        );
        
        return $sql->fetchAll();
    }
    
    public function buscaMesmaEstruturaVinculo($nrorg, $nrrateiovinc, $nrvinculom, $nrestruturam) {
        $sql = $this->entityManager->getConnection()->prepare(
        "SELECT * FROM FPA_ITRATEIOVINC WHERE (NRORG = :P_NRORG AND NRVINCULOM = :P_NRVINCULOM AND NRESTRUTURAM = :P_NRESTRUTURAM AND NRRATEIOVINC = :P_NRRATEIOVINC)"
        );
        
        $sql->execute(
            array(
                'P_NRORG' => $nrorg,
                'P_NRVINCULOM' => $nrvinculom,
                'P_NRESTRUTURAM' => $nrestruturam,
                'P_NRRATEIOVINC' => $nrrateiovinc
            )
        );
        
        return $sql->fetchAll();
    }
    
    public function existeItensRateio($nrorg, $nrrateiovinc) {
        $sql = $this->entityManager->getConnection()->prepare(
        "SELECT * FROM FPA_ITRATEIOVINC WHERE (NRORG = :P_NRORG AND NRRATEIOVINC = :P_NRRATEIOVINC)"
        );
        
        $sql->execute(
            array(
                'P_NRORG' => $nrorg,
                'P_NRRATEIOVINC' => $nrrateiovinc
            )
        );
        
        return $sql->fetchAll();
    }
    
    public function insereItemRateio($nrorg, $nritrateiovinc, $nrrateiovinc, $nrpeso, $vinculo, $nrestrutura, $auditoria) {
        $sql = $this->entityManager->getConnection()->prepare(
        "INSERT INTO FPA_ITRATEIOVINC 
            ( NRORG, 
              NRITRATEIOVINC, 
              NRRATEIOVINC, 
              NRPESO, 
              NRVINCULOM, 
              NRESTRUTURAM,
              DTINCLUSAO,
              DTULTATU,
              NRORGINCLUSAO,
              CDOPERINCLUSAO,
              NRORGULTATU,
              CDOPERULTATU )
         VALUES 
             ( :P_NRORG, 
               :P_NRITRATEIOVINC, 
               :P_NRRATEIOVINC, 
               :P_NRPESO, 
               :P_NRVINCULOM, 
               :P_NRESTRUTURAM,
               :P_DTINCLUSAO,
               :P_DTULTATU,
               :P_NRORGINCLUSAO,
               :P_CDOPERINCLUSAO,
               :P_NRORGULTATU,
               :P_CDOPERULTATU )"
        );
        
        return $sql->execute(
            array(
                'P_NRORG'          => $nrorg,
                'P_NRITRATEIOVINC' => $nritrateiovinc,
                'P_NRRATEIOVINC'   => $nrrateiovinc,
                'P_NRPESO'         => $nrpeso,
                'P_NRVINCULOM'     => $vinculo,
                'P_NRESTRUTURAM'   => $nrestrutura,
                'P_DTINCLUSAO'     => $auditoria['DTINCLUSAO'],
                'P_DTULTATU'       => $auditoria['DTULTATU'],
                'P_NRORGINCLUSAO'  => $auditoria['NRORGINCLUSAO'],
                'P_CDOPERINCLUSAO' => $auditoria['CDOPERINCLUSAO'],
                'P_NRORGULTATU'    => $auditoria['NRORGULTATU'],
                'P_CDOPERULTATU'   => $auditoria['CDOPERULTATU']
            )
        );
    }
}