<?php

namespace HCM\Geral\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;

class GpetpmovtransfmEntity extends TkEntity
{

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_mesCompetencia;

    public function __construct($entityManager, $hcmParameters){

        parent::__construct(null, $entityManager);
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->_nrOrg = $hcmParameters->getNrorgTrabalho();
        $this->_mesCompetencia = $hcmParameters->getDtCompetencia();
        $this->_nrOrgPadrao = $hcmParameters->getNrorgPadrao();
    }


    /**
     * Enter description here ...
     *
     * @param integer $nrTpMovTransf Numero do Tipo de Tranferencia.
     *
     * @return Ambigous <NULL, mixed>|NULL
     */
    public function retornaTpMovTransf($nrTpMovTransf){
        $tpMovTransf = $this->entityManager->getRepository(Repositories::GPE_TPMOVTRANSFM)->retornaTipoMovimentacaoTransferencia(
            $this->_nrOrgPadrao, $this->_nrOrg, $nrTpMovTransf
        );
        if (is_object($tpMovTransf) === true) {
            // Retorna o historico mais atual, de acordo com a data.
            $historico = $this->entityManager->getRepository(Repositories::GPE_TPMOVTRANSFH)->retornaTipoMovimentacaoTransferenciaHistorico(
                   $this->_nrOrgPadrao, $this->_nrOrg, $this->_mesCompetencia, $nrTpMovTransf
                );

            $tpMovTransf->historico = $historico;
            return $tpMovTransf;
        } else {
            return null;
        }
    }


}