<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 11/08/2016
 * Time: 16:28
 */

namespace HCM\Geral\Services;

use HCM\Util\HCMParameters;
use Zeedhi\Framework\HTTP\Kernel;

class FileService {

    protected $hcmParameters;
    protected $httpKernel;

    public function __construct(Kernel $httpKernel, HCMParameters $hcmParameters) {
        $this->httpKernel    = $httpKernel;
        $this->hcmParameters = $hcmParameters;

    }

    public function uploadFile($files, $module='geral', $customFilePath=null) {
        try {
            $nrorgtrab = $this->hcmParameters->getNrorgTrabalho();
            $constDir = realpath(__DIR__ . '/../../../../../../../anexos');

            // default directory
            $defaultUploadDir = array(
                'pebbian' => '',
                $nrorgtrab => '',
                'hcm_' . strtolower($module) => '',
                'uploads' => ''
            );

            $uploadDir = $this->createDirectory($constDir, $defaultUploadDir);
            if (!file_exists($uploadDir)) {
                $this->directoryCheck($uploadDir . '/');
            }

            // path to save files
            $filePath = array(
                'pebbian' => '',
                $nrorgtrab => '',
                'hcm_' . strtolower($module) => '',
                'anexos' => '');

            if (is_array($customFilePath)) {
                array_push($filePath, $customFilePath);
            }

            $filePath = $this->createDirectory($constDir, $filePath);
            if (!file_exists($filePath)) {
                $this->directoryCheck($filePath . '/');
            }

            foreach ($files as $fileData) {
                // upload temporary file into upload directory
                $tempFile = $this->httpKernel->factoryFromFileData($fileData, $uploadDir);
                // move uploaded file to file path directory
                $file = $tempFile->move($filePath, $fileData["name"]);
            }

            if (isset($file) && $file->isFile()) {
                return $filePath . '/' . $file->getFilename();
            } else {
                return null;
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    private function createDirectory($basic, array $directories){
        foreach($directories as $dir => $sub){
            if(!file_exists($basic)){
                $this->directoryCheck($basic);
            }
            $basic .= '/' . $dir . ($sub !== '' ? '/'.$sub : '');
        }
        return $basic;

    }

    private function directoryCheck($directory){
        if ( !is_dir($directory) && ! @mkdir($directory, 0777, true)) {
            throw new \InvalidArgumentException(sprintf(
                'O diretório "%s" não pode ser criado.',
                $directory
            ));
        }

        if ( ! is_writable($directory)) {
            throw new \InvalidArgumentException(sprintf(
                'O diretório "%s" não pode tem permissão de escrita.',
                $directory
            ));
        }
    }
} 