-- ============================================================
-- Table: FPA_RATEIOVINC
-- ============================================================
CREATE TABLE FPA_RATEIOVINC
(
    NRORG                 NUMBER          NOT NULL,
    NRRATEIOVINC          NUMBER          NOT NULL,
    DTINIVIGENCIA         DATE            NOT NULL,
    DTFIMVIGENCIA         DATE            NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_RATVIN CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_FPA_RATEIOVINC PRIMARY KEY (NRORG, NRRATEIOVINC)
)
/
-- ============================================================
-- Table: FPA_ITRATEIOVINC
-- ============================================================
CREATE TABLE FPA_ITRATEIOVINC
(
    NRORG                 NUMBER          NOT NULL,
    NRITRATEIOVINC        NUMBER          NOT NULL,
    NRRATEIOVINC          NUMBER          NOT NULL,
    NRVINCULOM            NUMBER          NOT NULL,
    NRESTRUTURAM          NUMBER          NOT NULL,
    NRPESO                NUMBER          NOT NULL,
    IDATIVO               VARCHAR2(1)     DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_ITRATVIN CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO            DATE            DEFAULT SYSDATE NOT NULL,
    DTULTATU              DATE            NULL,
    NRORGINCLUSAO         NUMBER(22)      DEFAULT 1 NULL,
    CDOPERINCLUSAO        VARCHAR2(12)    DEFAULT '1' NULL,
    NRORGULTATU           NUMBER(22)      DEFAULT 1 NULL,
    CDOPERULTATU          VARCHAR2(12)    DEFAULT '1' NULL,
    CONSTRAINT PK_FPA_ITRATEIOVINC PRIMARY KEY (NRORG, NRITRATEIOVINC),
    CONSTRAINT FK_RATITENS_NRRATVINC FOREIGN KEY (NRORG, NRRATEIOVINC) REFERENCES FPA_RATEIOVINC (NRORG, NRRATEIOVINC),
    CONSTRAINT FK_RATITENS_NRVINC FOREIGN KEY (NRORG, NRVINCULOM) REFERENCES GPE_VINCULOM (NRORG, NRVINCULOM),
    CONSTRAINT FK_RATITENS_ESTREMPR FOREIGN KEY (NRORG, NRESTRUTURAM) REFERENCES ESTRUTURAM (NRORG, NRESTRUTURAM)
)
/