<?php
namespace Planejamento\Logic\PrevisaoConsumo;

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;

class PrevisaoConsumo
{


    /**
     * Executa procedure CALCULA_PREVCONS_FILIAIS
     *
     * @param $nrorg
     * @param $filial
     * @param $grupo_filial
     * @param $dtcalculo
     * @param $acrescimo
     * @param $prodinicial
     * @param $prodfinal
     * @param $operador
     * @param $data_atual
     * @throws \Exception
     */
    public function executaProcedureCalculoPrevConsumo($nrorg, $filial, $grupo_filial, $dtcalculo, $acrescimo, $prodinicial, $prodfinal, $operador, $data_atual) {
        try {
            $procedure = new Procedure("CALCULA_PREVCONS_FILIAIS"); //Procedure 'SF_CALCULA_PREVCONS_FILIAIS'
            self::addParametrosGeraSolicitacao($procedure, $nrorg, $filial, $grupo_filial, $dtcalculo, $acrescimo, $prodinicial, $prodfinal, $operador, $data_atual);
            $procedure->call();
        } catch (\Exception $e) {
            throw $e;
        }
    }


    /**
     * Adiciona os parametros da procedure CALCULA_PREVCONS_FILIAIS.
     *
     * @static
     * @param Procedure $procedure Setforms2\Runtime\Helper\Procedure $procedure
     * @param $nrorg
     * @param $filial
     * @param $grupo_filial
     * @param $dtcalculo
     * @param $acrescimo
     * @param $prodinicial
     * @param $prodfinal
     * @param $operador
     * @param $data_atual
     */
    protected static function addParametrosGeraSolicitacao(
        Procedure $procedure, $nrorg, $filial, $grupo_filial, $dtcalculo, $acrescimo, $prodinicial, $prodfinal, $operador, $data_atual)
    {
//        $procedure->addParam(
//            new Param(
//                'P_NRORG',
//                Param::PARAM_INPUT,
//                $nrorg,
//                Param::PARAM_TYPE_INT
//            )
//        );
        $procedure->addParam(
            new Param(
                'P_CDFILIAL',
                Param::PARAM_INPUT,
                $filial,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_TCDFILIAL',
                Param::PARAM_INPUT,
                '',
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_CDGRUPFILI',
                Param::PARAM_INPUT,
                $grupo_filial,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_DTFINAL',
                Param::PARAM_INPUT,
                $dtcalculo,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_PEACRESCIMO',
                Param::PARAM_INPUT,
                $acrescimo,
                Param::PARAM_TYPE_INT
            )
        );
        $procedure->addParam(
            new Param(
                'P_CDPRODUTOINI',
                Param::PARAM_INPUT,
                $prodinicial,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_CDPRODUTOFIN',
                Param::PARAM_INPUT,
                $prodfinal,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_CDOPERADOR',
                Param::PARAM_INPUT,
                $operador,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_DTHRCALCPC',
                Param::PARAM_INPUT,
                $data_atual,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_IDARREDOND',
                Param::PARAM_INPUT,
                'N',
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_STDTINICIAL',
                Param::PARAM_INPUT,
                null,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_STDTFINAL',
                Param::PARAM_INPUT,
                null,
                Param::PARAM_TYPE_STR
            )
        );
    }


}
