create or replace PROCEDURE USR_NF_DEVO_AF(
P_CDFILIAL      IN VARCHAR,
P_NRLANCTONF    IN VARCHAR,
P_CDPRODUTO     IN VARCHAR,
P_NRSEQITPROD   IN VARCHAR,
P_QTITEMPROD    IN FLOAT,
P_VRUNITITEM    IN FLOAT
)
IS
--QT PROGMADA AF 
V_CDFILDEST     NFRELACAF.CDFILDEST%TYPE;
V_CDFILLANC     NFRELACAF.CDFILLANC%TYPE;
V_NRAUTOFORN    NFRELACAF.NRAUTOFORN%TYPE;
V_CDMARCA       NFRELACAF.CDMARCA%TYPE;
V_CDPRODUTO     NFRELACAF.CDPRODUTO%TYPE;
V_DTPROGENTAF   ITEMAUTF.DTPROGENTAF%TYPE;
V_IDBAIXITMAF   ITEMAUTF.IDBAIXITMAF%TYPE;
V_NRAUTOFORNE   ITEMPRODUTO.NRAUTOFORN%TYPE;
V_QTPROGENTAF   ITEMAUTF.QTPROGENTAF%TYPE;
V_QTEFETENTRAF  ITEMAUTF.QTEFETENTRAF%TYPE;
--QT ENTRA AF
V_CDFILIAL      NFRELACAF.CDFILIAL%TYPE;
V_NRLANCTONF    NFRELACAF.NRLANCTONF%TYPE;
V_QTITEMPROD    ITEMPRODUTO.QTITEMPROD%TYPE;
--ESPECIFICO TABELA INT
V_ERRO 			VARCHAR2(5000);
V_OBS			VARCHAR2(5000);
--VARIAVEIS LOCAIS MUTAVEIS
V_JACADASTRADO    NUMBER;
V_EXISTEAF        NUMBER;
JOB_N             INT;
V_QTAF            FLOAT;
V_QTNFENTRADA     FLOAT;
V_QTDEVOLVIDA     FLOAT;
V_ACRESCIMO       FLOAT;
V_DECRESCIMO      FLOAT;
V_QTDEVOLUCAO     FLOAT;
V_QTENTREGUE      FLOAT;
V_QTNENTREGUE     FLOAT;
V_STATUS          VARCHAR2(1);
V_BAIXAFUTURA     VARCHAR2(1);
V_IDDEVOLUCAONFIT VARCHAR2(1);
CURSOR C_QTPROGRAMADAAF IS
    SELECT N.CDFILDEST, N.CDFILLANC, N.NRAUTOFORN, N.CDMARCA,
           N.CDPRODUTO, IAF.DTPROGENTAF, IAF.IDBAIXITMAF,IT.NRAUTOFORN AS NRAUTOFORNE,
           SUM(IAF.QTPROGENTAF) QTPROGENTAF, SUM(IAF.QTEFETENTRAF) QTEFETENTRAF
    FROM ITEMNOTAFISC I, NFRELACAF N, ITEMPRODUTO IT, ITEMAUTF IAF
     WHERE I.CDFILIAL     = P_CDFILIAL
       AND I.NRLANCTONF   = P_NRLANCTONF
       AND I.CDFILIALIT   = N.CDFILIAL
       AND I.NRLANCTONFIT = N.NRLANCTONF
       AND N.CDFILIAL     = IT.CDFILIAL
       AND N.NRLANCTONF   = IT.NRLANCTONF
       AND IT.VRUNITITEM  = P_VRUNITITEM
       AND IT.NRAUTOFORN  IS NOT NULL
       AND IT.CDPRODUTO   = N.CDPRODUTO
       AND N.CDFILDEST    = IAF.CDFILDEST
       AND N.CDFILLANC    = IAF.CDFILLANC
       AND N.NRAUTOFORN   = IAF.NRAUTOFORN
       AND N.CDMARCA      = IAF.CDMARCA
       AND N.CDPRODUTO    = IAF.CDPRODUTO
       AND N.CDPRODUTO    = P_CDPRODUTO
    GROUP BY N.CDFILDEST, N.CDFILLANC, N.NRAUTOFORN, N.CDMARCA,
             N.CDPRODUTO, IAF.DTPROGENTAF, IAF.IDBAIXITMAF, IT.NRAUTOFORN
    ORDER BY N.CDPRODUTO, N.NRAUTOFORN DESC, QTPROGENTAF DESC,  IAF.DTPROGENTAF DESC;
CURSOR C_QTENTRADAAF IS    
    SELECT N.CDFILIAL, N.NRLANCTONF, SUM(N.QTITEMPROD) AS QTITEMPROD
              FROM (SELECT DISTINCT IT.CDFILIAL, IT.NRLANCTONF, IT.QTITEMPROD
                      FROM ITEMNOTAFISC I, NFRELACAF AF, NFRELACAF AF1, ITEMPRODUTO IT
                     WHERE I.CDFILIAL = P_CDFILIAL
                       AND I.NRLANCTONF = P_NRLANCTONF
                       AND I.CDFILIALIT = AF.CDFILIAL
                       AND I.NRLANCTONFIT = AF.NRLANCTONF
                       AND AF.CDPRODUTO = P_CDPRODUTO
                       AND AF.CDFILDEST = AF1.CDFILDEST
                       AND AF.CDFILLANC = AF1.CDFILLANC
                       AND AF.NRAUTOFORN = AF1.NRAUTOFORN
                       AND AF.CDMARCA = AF1.CDMARCA
                       AND AF.CDPRODUTO = AF1.CDPRODUTO
                       AND AF.DTPROGENTAF = AF1.DTPROGENTAF
                       AND AF1.CDFILIAL = IT.CDFILIAL
                       AND AF1.NRLANCTONF = IT.NRLANCTONF
                       AND AF1.CDPRODUTO = IT.CDPRODUTO
                       AND IT.VRUNITITEM = P_VRUNITITEM) N
            GROUP BY N.CDFILIAL, N.NRLANCTONF;
CURSOR C_QTDEVOLVIDAAF IS  
    SELECT N.CDFILIAL, N.NRLANCTONF, SUM(N.QTITEMPROD) QTITEMPROD
            FROM (SELECT DISTINCT IT.CDFILIAL, IT.NRLANCTONF, IT.QTITEMPROD
                    FROM ITEMNOTAFISC I, NFRELACAF AF, NFRELACAF AF1,ITEMNOTAFISC I1, ITEMPRODUTO IT
                   WHERE I.CDFILIAL = P_CDFILIAL
                     AND I.NRLANCTONF = P_NRLANCTONF
                     AND I.CDFILIALIT = AF.CDFILIAL
                     AND I.NRLANCTONFIT = AF.NRLANCTONF
                     AND AF.CDFILDEST = AF1.CDFILDEST
                     AND AF.CDFILLANC = AF1.CDFILLANC
                     AND AF.NRAUTOFORN = AF1.NRAUTOFORN
                     AND AF.CDMARCA = AF1.CDMARCA
                     AND AF.CDPRODUTO = AF1.CDPRODUTO
                     AND AF.DTPROGENTAF = AF1.DTPROGENTAF
                     AND AF1.CDFILIAL = I1.CDFILIALIT
                     AND AF1.NRLANCTONF =  I1.NRLANCTONFIT
                     AND I1.CDFILIAL = IT.CDFILIAL
                     AND I1.NRLANCTONF = IT.NRLANCTONF
                     AND IT.CDPRODUTO = P_CDPRODUTO
                     AND IT.VRUNITITEM = P_VRUNITITEM
                     AND I1.CDFILIAL||I1.NRLANCTONF <> P_CDFILIAL||P_NRLANCTONF) N
            GROUP BY N.CDFILIAL, N.NRLANCTONF;
BEGIN
    V_QTAF := 0;
    V_QTNFENTRADA := 0;
    V_QTDEVOLVIDA := 0;
    V_ACRESCIMO := 0;
    V_DECRESCIMO := 0;
    V_QTDEVOLUCAO := 0;
    ATUALIZA_QTRELAC_ITNFORIGEM(P_CDFILIAL, P_NRLANCTONF, P_NRSEQITPROD, 0, 'A');
    DBMS_OUTPUT.PUT_LINE('INICIO'); 
    --VERIFICA SE EXISTE AF
    SELECT COUNT(I.CDPRODUTO)
    INTO V_EXISTEAF
    FROM ITEMPRODUTO I, ITEMNOTAFISC IT, NFRELACAF NF
    WHERE IT.CDFILIAL   = P_CDFILIAL
    AND IT.NRLANCTONF   = P_NRLANCTONF
    AND I.CDPRODUTO     = P_CDPRODUTO
    AND IT.CDFILIALIT   = I.CDFILIAL
    AND IT.NRLANCTONFIT = I.NRLANCTONF
    AND I.CDPRODUTO     = NF.CDPRODUTO
    AND I.CDFILIAL      = NF.CDFILIAL
    AND I.NRLANCTONF    = NF.NRLANCTONF;
    DBMS_OUTPUT.PUT_LINE('V_EXISTEAF = '||V_EXISTEAF); 
    IF(V_EXISTEAF > 0) THEN
      OPEN C_QTPROGRAMADAAF;
      LOOP
        FETCH C_QTPROGRAMADAAF INTO V_CDFILDEST,
                                    V_CDFILLANC,
                                    V_NRAUTOFORN,
                                    V_CDMARCA,
                                    V_CDPRODUTO,
                                    V_DTPROGENTAF,
                                    V_IDBAIXITMAF,
                                    V_NRAUTOFORNE,
                                    V_QTPROGENTAF,
                                    V_QTEFETENTRAF;
                          EXIT WHEN C_QTPROGRAMADAAF%NOTFOUND;
                V_QTAF := V_QTAF+V_QTPROGENTAF; -- ta certo
      END LOOP;
      CLOSE C_QTPROGRAMADAAF;
      DBMS_OUTPUT.PUT_LINE('V_QTAF = '||V_QTAF); 
      OPEN C_QTENTRADAAF;
      LOOP
        FETCH C_QTENTRADAAF INTO V_CDFILIAL,
                                 V_NRLANCTONF,
                                 V_QTITEMPROD;
                          EXIT WHEN C_QTENTRADAAF%NOTFOUND;
                V_QTNFENTRADA := V_QTNFENTRADA+V_QTITEMPROD;
      END LOOP;
      CLOSE C_QTENTRADAAF;
      DBMS_OUTPUT.PUT_LINE('V_QTNFENTRADA = '||V_QTNFENTRADA); 
      OPEN C_QTDEVOLVIDAAF;
      LOOP
        FETCH C_QTDEVOLVIDAAF INTO V_CDFILIAL,
                                   V_NRLANCTONF,
                                   V_QTITEMPROD;
                          EXIT WHEN C_QTDEVOLVIDAAF%NOTFOUND;
                V_QTDEVOLVIDA := V_QTDEVOLVIDA+V_QTITEMPROD;
      END LOOP;
      CLOSE C_QTDEVOLVIDAAF;
      DBMS_OUTPUT.PUT_LINE('V_QTDEVOLVIDA = '||V_QTDEVOLVIDA); 
      IF(V_QTNFENTRADA > V_QTAF + V_QTDEVOLVIDA) THEN
          V_ACRESCIMO := V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA);
          V_DECRESCIMO := 0;
      ELSE
          V_ACRESCIMO := 0;
          V_DECRESCIMO := V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA);
      END IF;
      IF(P_QTITEMPROD <= V_ACRESCIMO) THEN
          V_QTDEVOLUCAO := 0;
      ELSE
          V_QTDEVOLUCAO := P_QTITEMPROD - V_ACRESCIMO;
      END IF;
      OPEN C_QTPROGRAMADAAF;
      LOOP
        FETCH C_QTPROGRAMADAAF INTO V_CDFILDEST,
                                    V_CDFILLANC,
                                    V_NRAUTOFORN,
                                    V_CDMARCA,
                                    V_CDPRODUTO,
                                    V_DTPROGENTAF,
                                    V_IDBAIXITMAF,
                                    V_NRAUTOFORNE,
                                    V_QTPROGENTAF,
                                    V_QTEFETENTRAF;
                          EXIT WHEN C_QTPROGRAMADAAF%NOTFOUND;
                IF(V_QTDEVOLUCAO > 0) THEN
                  ----- NOTA SENDO ALTERADA ----
                    IF(V_QTEFETENTRAF = 0) THEN
                        IF((V_QTDEVOLUCAO + V_QTDEVOLVIDA) < V_QTPROGENTAF) THEN
                            V_STATUS := '1'; -- BAIXA PARCIAL
                            V_BAIXAFUTURA := NULL;
                            IF(V_QTDEVOLVIDA > 0) THEN
                                IF(V_QTNFENTRADA < (V_QTAF + V_QTDEVOLVIDA)) THEN
                                    V_QTENTREGUE := (V_QTPROGENTAF + (V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA))) - (V_QTDEVOLUCAO + V_QTDEVOLVIDA);
                                    V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                                ELSE
                                    V_QTENTREGUE := V_QTPROGENTAF - (V_QTDEVOLUCAO + V_QTDEVOLVIDA);
                                    V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                                END IF;
                                IF(V_QTENTREGUE = 0) THEN
                                    V_STATUS := NULL; -- EM ABERTO
                                END IF;
                            ELSE -- V_QTDEVOLVIDA > 0
                                IF(V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA) < 0) THEN
                                    V_QTENTREGUE := (V_QTPROGENTAF + (V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA))) - V_QTDEVOLUCAO;
                                    V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                                ELSE
                                    V_QTENTREGUE := V_QTPROGENTAF - V_QTDEVOLUCAO;
                                    V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                                END IF;
                                IF(V_QTENTREGUE = 0) THEN
                                    V_STATUS := NULL; -- EM ABERTO
                                END IF;
                            END IF; -- V_QTDEVOLVIDA > 0
                        ELSE -- (V_QTDEVOLUCAO + V_QTDEVOLVIDA) < V_QTPROGENTAF
                            V_STATUS := NULL; -- EM ABERTO
                            V_BAIXAFUTURA := 'X';
                            IF(V_QTDEVOLVIDA > 0) THEN
                                IF(V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA) < 0) THEN
                                    IF((V_QTDEVOLUCAO + V_QTDEVOLVIDA) > (V_QTPROGENTAF + (V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA)))) THEN
                                        V_QTENTREGUE := 0;
                                        V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                                        V_QTDEVOLUCAO := V_QTDEVOLUCAO + V_QTDEVOLVIDA;
                                    ELSE 
                                        V_QTENTREGUE := (V_QTPROGENTAF + (V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA))) - (V_QTDEVOLUCAO + V_QTDEVOLVIDA);
                                        V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                                    END IF; --(V_QTDEVOLUCAO + V_QTDEVOLVIDA) > (V_QTPROGENTAF + (V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA)))
                                ELSE -- V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA) < 0
                                    IF((V_QTDEVOLUCAO + V_QTDEVOLVIDA) > V_QTPROGENTAF) THEN
                                        V_QTENTREGUE := 0;
                                        V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                                    ELSE
                                        V_QTENTREGUE := V_QTPROGENTAF - (V_QTDEVOLUCAO + V_QTDEVOLVIDA);
                                        V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                                    END IF;
                                END IF; -- V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA) < 0
                            ELSE --V_QTDEVOLVIDA > 0
                                IF(V_QTDEVOLUCAO >= V_QTPROGENTAF) THEN
                                    V_QTENTREGUE := 0;
                                    V_QTNENTREGUE := V_QTPROGENTAF;
                                ELSE
                                    IF((V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA)) < 0) THEN
                                        V_QTENTREGUE := (V_QTPROGENTAF - (V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA))) - V_QTDEVOLUCAO;
                                        V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                                        V_QTENTREGUE := V_QTPROGENTAF - V_QTDEVOLUCAO;
                                        V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                                    END IF;
                                END IF;
                            END IF; --V_QTDEVOLVIDA > 0
                        END IF; -- (V_QTDEVOLUCAO + V_QTDEVOLVIDA) < V_QTPROGENTAF
                    IF(V_QTENTREGUE = 0) THEN
                        V_STATUS := NULL;
                        V_BAIXAFUTURA := 'X';
                    END IF;
                    ELSE -- END V_QTEFETENTRAF = 0
                        IF(V_QTDEVOLVIDA > 0) THEN
                            DBMS_OUTPUT.PUT_LINE('V_QTDEVOLVIDA > 0 V_QTPROGENTAF = '||V_QTPROGENTAF||' V_QTDEVOLUCAO = '||V_QTDEVOLUCAO||' V_QTDEVOLVIDA = '||V_QTDEVOLVIDA); 
                            IF((V_QTDEVOLUCAO + V_QTDEVOLVIDA) = V_QTPROGENTAF ) THEN
                                V_STATUS := NULL;
                                V_BAIXAFUTURA := 'X';
                            ELSE
                                V_STATUS := '1';
                                V_BAIXAFUTURA := NULL;
                            END IF;
                            IF((V_QTPROGENTAF - (V_QTDEVOLUCAO + V_QTDEVOLVIDA)) > 0) THEN
                                V_QTENTREGUE := (V_QTPROGENTAF + (V_QTNFENTRADA - (V_QTAF + V_QTDEVOLVIDA))) - (V_QTDEVOLUCAO + V_QTDEVOLVIDA);--V_QTPROGENTAF - (V_QTDEVOLUCAO + V_QTDEVOLVIDA); --ESTA CONTA ESTAva ERRADA. 
                                V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                            ELSE
                                V_QTENTREGUE := 0;
                                V_QTNENTREGUE := V_QTPROGENTAF;
                            END IF;
                        ELSE --V_QTDEVOLVIDA > 0
                            IF(V_QTDEVOLUCAO = V_QTPROGENTAF) THEN
                                V_STATUS := NULL;
                                V_BAIXAFUTURA := 'X';
                            ELSE
                                V_STATUS := '1';
                                V_BAIXAFUTURA := NULL;
                            END IF;
                            IF((V_QTPROGENTAF - V_QTDEVOLUCAO > 0)) THEN
                                V_QTENTREGUE := V_QTPROGENTAF - V_QTDEVOLUCAO;
                                V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                            ELSE
                                V_QTENTREGUE := 0;
                                V_QTNENTREGUE := V_QTPROGENTAF;
                            END IF;
                        END IF; -- V_QTDEVOLVIDA > 0
                        IF(V_QTENTREGUE = 0) THEN
                            V_STATUS := NULL;
                            V_BAIXAFUTURA := 'X';
                        END IF;
                    END IF; -- END V_QTEFETENTRAF = 0
                    V_IDDEVOLUCAONFIT := 'S';
                    DBMS_OUTPUT.PUT_LINE('UPDATE1'); 
                    DBMS_OUTPUT.PUT_LINE('PARAMETROS V_STATUS ='||V_STATUS||' V_QTEFETENTRAF = '||V_QTEFETENTRAF||' V_QTENTREGUE = '||V_QTENTREGUE||' V_QTNENTREGUE = '||V_QTNENTREGUE); 
                    UPDATE ITEMAUTF
                    SET IDBAIXITMAF     = V_STATUS,
                        QTEFETENTRAF    = V_QTENTREGUE,
                        IDDEVOLUCAONFIT = V_IDDEVOLUCAONFIT 
                    WHERE 
                        CDFILDEST = V_CDFILDEST
                    AND CDFILLANC = V_CDFILLANC
                    AND NRAUTOFORN = V_NRAUTOFORN
                    AND CDMARCA     = V_CDMARCA
                    AND CDPRODUTO   = V_CDPRODUTO;
                    IF(V_BAIXAFUTURA IS NOT NULL) THEN
                        UPDATE ITEMAUTF
                        SET IDBAIXITMFUTURA     = V_BAIXAFUTURA
                        WHERE 
                            CDFILDEST = V_CDFILDEST
                        AND CDFILLANC = V_CDFILLANC
                        AND NRAUTOFORN = V_NRAUTOFORN
                        AND CDMARCA     = V_CDMARCA
                        AND CDPRODUTO   = V_CDPRODUTO;
                    END IF;
                    --ATUALIZA QTDEVOLVIDA
                    IF(V_QTDEVOLUCAO > V_QTDEVOLVIDA) THEN
                        V_QTDEVOLVIDA := 0;
                    ELSE
                        V_QTDEVOLVIDA := V_QTDEVOLVIDA - V_QTDEVOLUCAO;
                    END IF;
                    V_QTDEVOLUCAO := V_QTDEVOLUCAO - V_QTNENTREGUE;
                ELSE -- V_QTDEVOLUCAO > 0
                    V_STATUS := '2';
                    IF(V_DECRESCIMO < 0 AND V_QTDEVOLUCAO = 0)THEN
                        V_STATUS := '1'; -- BAIXA PARCIAL
                        V_QTENTREGUE := (V_QTPROGENTAF + V_DECRESCIMO) - ABS(V_QTDEVOLUCAO);
                        V_QTNENTREGUE := V_QTPROGENTAF - V_QTENTREGUE;
                    ELSE
                        V_QTENTREGUE := V_QTPROGENTAF;
                        V_QTNENTREGUE := 0;
                    END IF;
                    IF(V_QTENTREGUE = 0) THEN
                      V_STATUS := NULL;
                    END IF;
                    V_BAIXAFUTURA := NULL;
                    IF(V_DECRESCIMO < 0 AND V_QTDEVOLUCAO = 0) THEN
                        V_IDDEVOLUCAONFIT := 'S';
                    ELSE
                        V_IDDEVOLUCAONFIT := 'N';
                    END IF;
                    DBMS_OUTPUT.PUT_LINE('UPDATE2'); 
                    UPDATE ITEMAUTF
                    SET IDBAIXITMAF     = V_STATUS,
                        QTEFETENTRAF    = V_QTENTREGUE,
                        IDDEVOLUCAONFIT = V_IDDEVOLUCAONFIT
                    WHERE 
                        CDFILDEST = V_CDFILDEST
                    AND CDFILLANC = V_CDFILLANC
                    AND NRAUTOFORN = V_NRAUTOFORN
                    AND CDMARCA     = V_CDMARCA
                    AND CDPRODUTO   = V_CDPRODUTO;
                    IF(V_BAIXAFUTURA IS NOT NULL) THEN
                        UPDATE ITEMAUTF
                        SET IDBAIXITMFUTURA     = V_BAIXAFUTURA
                        WHERE 
                            CDFILDEST = V_CDFILDEST
                        AND CDFILLANC = V_CDFILLANC
                        AND NRAUTOFORN = V_NRAUTOFORN
                        AND CDMARCA     = V_CDMARCA
                        AND CDPRODUTO   = V_CDPRODUTO;
                    END IF;
                END IF; -- END V_QTDEVOLUCAO > 0
      END LOOP;
      CLOSE C_QTPROGRAMADAAF;
    END IF; -- END EXISTEAF > 0
   COMMIT;
EXCEPTION
WHEN OTHERS THEN
  V_ERRO := SQLERRM(SQLCODE); 
  ROLLBACK;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_NF_DEVO_AF','6.35.021'); END;
/
